// TsRename.cpp : R\[ AvP[ṼGg |Cg`܂B
//
#pragma warning(disable : 4996)

#include "stdafx.h"
#include <commctrl.h>
#include "TsRename.h"
#include <shellapi.h>
#include "TsData.h"
#include <winsock2.h>
#include <string>
#include <iostream>

using namespace std;

#pragma comment(lib,"ws2_32.lib")
#pragma	comment(lib,"comctl32.lib")

#define MAX_LOADSTRING 100

typedef struct tagProgList {
	string	stName;
	string	stNameBack;
	string	stCont;
	string	stDetails;
	string	stChName;
	string	stSyobo;
	string	stSyoboName;
	string	stSyoboTT;
	string	stSyoboNB;
	string	stSyoboSB;
	string	stSyoboCH;
	string	stSyoboCHBack;
	string	stSyoboLastSetting;
	string	stDate;
	string	stSTime;
	string	stDate28;
	string	stSTime28;
	string	stYDate;
	string	stYDate28;
	string	stY2Date;
	string	stY2Date28;
	string	stS2Time;
	string	stS2Time28;
	string	stYDateSTime;
	string	stYDateSTime28;
	string	stY2_Date;
	string	stY2_Date28;
	string	stY3_Date;
	string	stY3_Date28;
	string	stY4_Date;
	string	stY4_Date28;
	string	stAv;
	string	stGenre0;
	string	stGenre;
	string	stGenre2;
	string	stContAll;
	string	stContLine;
	WORD	serviceId;
	WORD	eventId;
	DWORD	vCount;
	time_t	stime;
	time_t	etime;

	tagProgList() {
		memset(this,0,sizeof(PROG_DATA));
	}
} PROG_DATA;

typedef struct tagFileList {
	string	stFileName;
	string	stFilePath;
	string	stNewName;
	string	stNewFilePath;
	BOOL	bFileNameError;
	int		nSelNo;
	vector<PROG_DATA>	progList;
	tagFileList() {
		memset(this,0,sizeof(FILE_DATA));
	}
	BOOL bChange;
} FILE_DATA;

typedef struct tagChNameList {
	string	szChName;
	string	szSubName;
} CH_NAME;

typedef struct tagNumberring {
	time_t	stime;
	int		sno;
	BOOL	bWeekCheck[7];
	void Reset(void) {
		stime = 0;
		sno = 0;
		memset(bWeekCheck,0,sizeof(bWeekCheck));
	}
	tagNumberring() {
		Reset();
	}
} NUM_DATA;

typedef struct tagSyoboData {
	string stSyobo;
	string stDate;
	string stTime;
	string stName;
	string stCh;
} SYOBO_DATA;

typedef struct tagTvRockReName {
	string	stFind;
	string	stFindCh;
	int		type;
	string	stRename;
	string	stSyoboFind;
	BOOL	bSyoboTT;
	BOOL	bSyoboNB;
	BOOL	bSyoboSB;
	BOOL	bSyoboCH;
	vector<NUM_DATA> numList;
	void Reset(void) {
		stFind.clear();
		stFindCh.clear();
		type = 0;
		stRename.clear();
		stSyoboFind.clear();
		bSyoboTT = FALSE;
		bSyoboNB = FALSE;
		bSyoboSB = FALSE;
		bSyoboCH = FALSE;
		numList.clear();
	}
	tagTvRockReName() {
		Reset();
	}
} RENAME_DATA;

// O[oϐ :
HINSTANCE hInst;								// ݂̃C^[tFCX
TCHAR szTitle[MAX_LOADSTRING];					// ^Cg o[̃eLXg
TCHAR szWindowClass[MAX_LOADSTRING];			// C EBhE NX
TCHAR m_szIniPath[256];
vector<FILE_DATA> m_FileList;
CTsData* m_pTs = NULL;
const char*		m_FileReadDlg_FileName = NULL;
BOOL m_bTsreadCancel = FALSE;
BOOL b_bFileReadFrst = TRUE;
int	m_nSelectItemNo = 0;
int	m_nSelectItemNoItem = 0;
POINT m_nSelectItemPos;
string m_stEdtName;
string m_stCont;
BOOL m_bFileDate = FALSE;
BOOL m_bNotFileRename = FALSE;
BOOL m_bGopRename = FALSE;
BOOL m_bWildRename = FALSE;
BOOL m_bIconStart = FALSE;
char* m_szCmdLine = NULL;
int m_nReadStartPos = 30;
int m_nReadSize = 300;
BOOL m_bAuto = FALSE;
BOOL m_bQuit = FALSE;
vector<RENAME_DATA> m_RenameList;
char* m_szType[3] = {"","ԑg",""};
int m_numPos = 0;

// ̃R[h W[Ɋ܂܂֐̐錾]܂ :
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK TsRenameDlgProc(HWND hWnd,UINT meg,WPARAM wp,LPARAM lp);
LRESULT CALLBACK FileReadDlgProc(HWND hWnd,UINT meg,WPARAM wp,LPARAM lp);
LRESULT CALLBACK NameEditDlgProc(HWND hWnd,UINT meg,WPARAM wp,LPARAM lp);
LRESULT CALLBACK SetupDlgProc(HWND hWnd,UINT meg,WPARAM wp,LPARAM lp);
LRESULT CALLBACK TvRockReNameDlgProc(HWND hWnd,UINT meg,WPARAM wp,LPARAM lp);
LRESULT CALLBACK TvRockSetupDlgProc(HWND hWnd,UINT meg,WPARAM wp,LPARAM lp);
BOOL tsreadCallBack(long readbyte,long totalbyte,HWND data);
void ProgSel(HWND hWnd,int itemNo);
void ContDisp(HWND hWnd,int nItemNo);
BOOL ReadEpgData(HWND hWnd,int i,char* szPathName);

unsigned char	*utf8ToSjis(char *utf8)
{
	wchar_t* utf16 = NULL;

	if ( utf8	==	NULL )
		return	NULL;

	//==============================//
	//	UTF8=UTF16ϊ	    //
	//==============================//
	//	܂́Awlen̒Ƃ
    	const int wlen = MultiByteToWideChar(CP_UTF8, 0, utf8, -1, NULL, 0);
    	if (!wlen)
	{
		return NULL;
	}

	//	utf16̗̈m
	utf16 = new wchar_t[wlen + 1];
	if ( utf16	==	NULL )
	{
		return NULL;
	}

	//	utf16ϊ
	if ( MultiByteToWideChar(CP_UTF8, 0, utf8, -1, utf16, wlen) > 0 )
	{
        utf16[wlen] = L'0';
	}
	else
	{
		delete utf16;
		return NULL;
	}


	//==============================//
	//	UTF16=ShiftJISϊ   //
	//==============================//
	//	܂́A擾
	const int mlen = WideCharToMultiByte(CP_ACP,0,utf16,-1,NULL,0," ",NULL);
	if (!mlen)
	{
		delete utf16;
		return NULL;
	}

	//	̈m
	unsigned char	*sjis = new unsigned char[mlen + 1];
	if ( sjis	==	NULL )
	{
		delete utf16;
		return NULL;
	}

	//	utf16ϊ
	if ( WideCharToMultiByte(CP_ACP,0,utf16,-1,(LPSTR)sjis,mlen," ",NULL) > 0 )
	{
	        sjis[mlen] = 0;
	}
	else
	{
		delete	utf16;
		delete	sjis;
		return NULL;
	}

	//	Ƃ܂
	delete utf16;

	return sjis;
}

unsigned char	*SjisToutf8(char *sjis)
{
	wchar_t* utf16 = NULL;

	if ( sjis	==	NULL )
		return	NULL;


	//==============================//
	//	SJIS=UTF16ϊ	    //
	//==============================//
	//	܂́Awlen̒Ƃ
    	const int wlen = MultiByteToWideChar(CP_ACP , 0, sjis, -1, NULL, 0);
    	if (!wlen)
	{
		return NULL;
	}

	//	utf16̗̈m
	utf16 = new wchar_t[wlen + 1];
	if ( utf16	==	NULL )
	{
		return NULL;
	}

	//	utf16ϊ
	if ( MultiByteToWideChar(CP_ACP, 0, sjis, -1, utf16, wlen) > 0 )
	{
        utf16[wlen] = L'0';
	}
	else
	{
		delete utf16;
		return NULL;
	}


	//==============================//
	//	UTF16=UTF8ϊ   //
	//==============================//
	//	܂́A擾
	const int mlen = WideCharToMultiByte(CP_UTF8,0,utf16,-1,NULL,0,NULL,NULL);
	if (!mlen)
	{
		delete utf16;
		return NULL;
	}

	//	̈m
	unsigned char	*utf8 = new unsigned char[mlen + 1];
	if ( utf8	==	NULL )
	{
		delete utf16;
		return NULL;
	}

	//	utf16ϊ
	if ( WideCharToMultiByte(CP_UTF8,0,utf16,-1,(LPSTR)utf8,mlen,NULL,NULL) > 0 )
	{
	        utf8[mlen] = 0;
	}
	else
	{
		delete	utf16;
		delete	utf8;
		return NULL;
	}

	//	Ƃ܂
	delete utf16;

	return utf8;
}

//HTTPANZXp =======================
#define WSOCK_GETHOST	WM_USER + 1	/* zXg̃Cxgʒm郁bZ[W */
#define WSOCK_SELECT	WM_USER + 2	/* \PbgCxgʒm郁bZ[W */

#define BUFSIZE			256			/* obt@TCY */
#define RECVSIZE		4069		/* MTCY */
#define OUTSIZE			32768		/* ~σobt@TCY */

#define ESC 0x1B					/* GXP[vR[h */

// global
HINSTANCE g_hinst;					/* AvP[ṼCX^Xnh */
char gHostEnt[MAXGETHOSTSTRUCT];	/* zXg擾obt@ */
HANDLE hGetHost;					/* zXg擾Ƃ̔񓯊ȃ^XÑnh */
int soc;							/* \PbgiSoket Descriptorj */
char SvName[BUFSIZE];				/* T[o */
char Path[BUFSIZE];					/* pX */
int Port;							/* |[gԍ */
char OUT_BUF[OUTSIZE];				/* M~ςobt@ */
BOOL bOut;

/*---------------------------------------------------
		̃Vtgs
---------------------------------------------------*/
void shift(int *ph,int *pl)
{
	if(*ph & 1){
		if(*pl < 0x60){
			*pl+=0x1F;
		}else{
			*pl+=0x20;
		}
	}else{
		*pl+=0x7E;
	}
	if(*ph < 0x5F){
		*ph = (*ph + 0xE1) >> 1;
	}else{
		*ph = (*ph + 0x161) >> 1;
	}
}

/*---------------------------------------------------
		JISSJISɕϊ
---------------------------------------------------*/
int JIS_SJIS(char *buf,char *ret)
{
	strcpy(ret,buf);
	return 0;

	unsigned int c,d,j;
	BOOL jiskanji,hankaku;
	char *p,*r;

	strcpy(ret,"");
	p = buf;
	r = ret;
	j = 0;
	jiskanji = FALSE;
	hankaku = FALSE;
	while(*p != '\0'){
		j++;
		c = *(p++);
		if(c == ESC){
			if((c = *(p++)) == '$'){
				if((c = *(p++)) == '@' || c == 'B'){
					jiskanji = TRUE;
				}else{
					*(r++) = ESC;
					*(r++) = '$';
					if(c != '\0'){
						*(r++) = c;
					}
				}
			}else if(c == '('){
				if((c = *(p++)) == 'H' || c == 'J' || c == 'B'){
					jiskanji = FALSE;
				}else{
					*(r++) = ESC;
					*(r++) = '(';
					if(c != '\0'){
						*(r++) = c;
					}
				}
			}else if(c == '*'){
				if((c = *(p++)) == 'B'){
					hankaku = FALSE;
				}else if(c == 'I'){
					hankaku = TRUE;
				}
			}else if(hankaku == TRUE && c == 'N'){
				c = *(p++);
				*(r++) = c + 0x80;
			}else if(c == 'K'){
				jiskanji = TRUE;
			}else if(c == 'H'){
				jiskanji = FALSE;
			}else{
				*(r++) = ESC;
				if(c != '\0'){
					*(r++) = c;
				}
			}
		}else if(jiskanji && c >= 0x21 && c <= 0x7E){
			if((d = *(p++)) >= 0x21 && d <= 0x7E){
				shift((int *)&c,(int *)&d);
			}
			*(r++) = c;
			if(d != '\0'){
				*(r++) = d;
			}
		}else if(c >= 0xA1 && c <= 0xFE){
			if((d = *(p++)) >= 0xA1 && d <= 0xFE){
				d &= 0x7E;
				c &= 0x7E;
				shift((int *)&c,(int *)&d);
			}
			*(r++) = c;
			if(d != '\0'){
				*(r++) = d;
			}
		}else if(c == 0x0E){
			while(*p != '\0' && *p != 0x0F){
				*(r++) = *(p++) + 0x80;
			}
			if(*p == 0x0F){
				p++;
			}
		}else{
			*(r++) = c;
		}
	}
	*r = '\0';
	return 0;
}

/*---------------------------------------------------
		URLT[oƃpXo֐
---------------------------------------------------*/
int GetURL(char *URL,char *server,char *path)
{
	char *p,*r,*t,wk[8];		/* Ɨp̈ */
	int i,port = 80;

	if(strlen(URL) <= 7){
		return -1;
	}
	/* XL[擾 */
	for(i = 0;i < 7;i++){
		wk[i] = URL[i];
	}
	wk[i] = '\0';
	if(strcmpi(wk,"http://") != 0){
		return -1;
	}

	/* T[o擾 */
	for(p = URL + i,r = server;*p != '/' && *p != '\0';p++,r++){
		*r = *p;
	}
	*r = '\0';

	/* 擾y[W̃pX擾 */
	for(r = path;*p != '\0';p++,r++){
		*r = *p;
	}
	*r = '\0';

	/* T[o:|[g ƂȂĂꍇ͕ */
	for(p = server;*p != ':' && *p != '\0';p++);
	if(*p == ':'){
		for(t = p + 1,r = wk;*t != '\0';t++,r++){
			*r = *t;
		}
		*r = '\0';
		port = atoi(wk);

		*p = '\0';
	}

	/* y[W̎w肪ꍇ́A/ ([g)ݒ肷 */
	if(strcmp(path,"") == 0){
		strcpy(path,"/");
	}
	return port;
}

/*---------------------------------------------------
		ҏW֐
---------------------------------------------------*/
void ConvBuf(char *buf)
{
	char *p,*r;
	char tmp[OUTSIZE];

	/* HTTPX|Xwb_̏I擾 */
	p = (char*)strstr(buf,"\r\n\r\n");			/* wb_̏I肪CRLF CRLF̏ꍇ */
	if(p != NULL){
		p+=4;
	}
	if(p == NULL){
		p = (char*)strstr(buf,"\n\n");			/* wb_̏I肪LF LF̏ꍇ */
		if(p != NULL){
			p+=2;
		}
	}
	if(p == NULL){
		p = (char*)strstr(buf,"\r\r");			/* wb_̏I肪CR CȐꍇ */
		if(p != NULL){
			p+=2;
		}
	}
	if(p == NULL){
		p = (char*)strstr(buf,"\n\r\n\r");		/* wb_̏I肪LFCR LFCȐꍇ */
		if(p != NULL){
			p+=4;
		}
	}
	if(p == NULL){						/* wb_̏I肪Ȃꍇ */
		p = buf;
	}

	/* wb_āAsLF̏ꍇɔCRLFɕϊ */
	for(r = tmp;*p != '\0';p++){
		if(*p == '\n'){
			*(r++) = '\r';
			*(r++) = '\n';
		}else if(*p == '\r'){
		}else{
			*(r++) = *p;
		}
	}
	*r = '\0';

	/* JISSJISɕϊ */
	JIS_SJIS(tmp,buf);
}

/*---------------------------------------------------
		\PbgCxg̒ʒmݒ肷֐
---------------------------------------------------*/
BOOL SocketSelect(int sSoc,HWND hWnd)
{
	/* ڑAMAؒf̃\PbgCxgʒm悤ɐݒ肷 */
	/* \PbgCxǵAEBhEWSOCK_SELECTbZ[WŒʒm悤ɐݒ肷 */
	if(WSAAsyncSelect(sSoc, hWnd, WSOCK_SELECT, FD_CONNECT | FD_READ | FD_CLOSE) == SOCKET_ERROR){
		return FALSE;
	}
	return TRUE;
}

/*---------------------------------------------------
		T[oɐڑvo֐
---------------------------------------------------*/
BOOL ConnectServer(int cSoc,unsigned long cIPaddr,int cPort)
{
	struct	sockaddr_in	serversockaddr;

	/* T[õAhX̍\̂ɃT[oIPAhXƃ|[gԍݒ肵܂ */
	serversockaddr.sin_family	= AF_INET;
	serversockaddr.sin_addr.s_addr = cIPaddr;						/* IPAhX */
	serversockaddr.sin_port		= htons((unsigned short)cPort);		/* |[gԍ */
	memset(serversockaddr.sin_zero,(int)0,sizeof(serversockaddr.sin_zero));
	/* T[oɃRlNg */
	if(connect(cSoc,(struct sockaddr *)&serversockaddr,sizeof(serversockaddr)) == SOCKET_ERROR){
		if(WSAGetLastError() != WSAEWOULDBLOCK){
			return FALSE;
		}
	}
	return TRUE;
}

/*---------------------------------------------------
		\Pbgj֐
---------------------------------------------------*/
void SocketClose(HWND hWnd)
{
	/* WSAAsyncGetHostByName֐̔񓯊ȃ^XNꍇ̓LZ */
	if(hGetHost != NULL){
		WSACancelAsyncRequest(hGetHost);
		hGetHost = NULL;
	}
	/* \PbgCxg̒ʒm */
	WSAAsyncSelect(soc, hWnd, 0,0);
	/* \Pbgj */
	closesocket(soc);
	soc = -1;

	//SetWindowText(hBTNGET,"GO");

}

/*---------------------------------------------------
		\Pbg̃G[֐
---------------------------------------------------*/
void SocketError(HWND hWnd,char *msgbuf)
{
	/* \Pbgj */
	SocketClose(hWnd);

	/* G[bZ[W */
	//MessageBox(hWnd,msgbuf,"Error",MB_OK | MB_ICONERROR);

}

/*---------------------------------------------------
		HTTPZbV̊Jn
---------------------------------------------------*/
void HTTPStart(HWND hWnd,char *buf)
{
	unsigned long serveraddr;		/* T[oIPAhX */

	/* URLT[oƃpX擾 */
	Port = GetURL(buf,SvName,Path);
	if(Port == -1){
		//MessageBox(hWnd, "URLsłB", "Error", MB_OK | MB_ICONERROR);
		//SetWindowText(hBTNGET,"GO");
		return;
	}
	/* socɃ\Pbg쐬܂ */
	soc = socket(PF_INET, SOCK_STREAM, 0);
	if(soc == INVALID_SOCKET){
		//MessageBox(hWnd, "Socket̍쐬Ɏs܂B", "Error", MB_OK | MB_ICONERROR);
		soc = -1;
		//SetWindowText(hBTNGET,"GO");
		return;
	}
	/* svNameɃhbgŋ؂10iIPAhXĂꍇAserveraddr32bitIPAhXԂ܂ */
	serveraddr = inet_addr((char*)SvName);
	if(serveraddr == -1){
		/* T[oT[õzXg擾 */
		/* zXg񂪎擾łƁAEBhEWSOCK_GETHOSTʒm悤ɂ */
		hGetHost = WSAAsyncGetHostByName(hWnd,WSOCK_GETHOST,SvName,gHostEnt, MAXGETHOSTSTRUCT);
		if(hGetHost == 0){
			SocketError(hWnd,"T[oIPAhX̎擾Ɏs܂B");
			return;
		}
		return;
	}
	/* ڑAMAؒf̃CxgEBhEbZ[WŒʒm悤ɂ */
	if(SocketSelect(soc, hWnd) == FALSE){
		SocketError(hWnd,"SocketCxgʒmݒɎs܂B");
		return;
	}

	/* T[oɐڑ */
	if(ConnectServer(soc,serveraddr,Port) == FALSE){
		SocketError(hWnd,"T[oւ̐ڑɎs܂B");
	}
}

/*---------------------------------------------------
		IPAhX擾ĐڑJn
---------------------------------------------------*/
void HTTPGetHostToIPaddr(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	struct hostent FAR *HostEntry;	/* zXg */
	unsigned long serveraddr;		/* T[oIPAhX */

	/* G[̔ */
	if(WSAGETASYNCERROR(lParam) != 0){
		SocketError(hWnd,"T[oIPAhX̎擾Ɏs܂B");
		return;
	}
	/* WSAAsyncGetHostByName̖߂lł񓯊ȃ^XÑnh*/
	if(hGetHost != (HANDLE)wParam){
		return;
	}
	HostEntry = (struct hostent FAR *)gHostEnt;
	serveraddr =  *((unsigned long *)((HostEntry->h_addr_list)[0]));	/* IPAhX擾 */

	hGetHost = NULL;

	/* \PbgCxgEBhEbZ[WŒʒm悤ɂ */
	if(SocketSelect(soc, hWnd) == FALSE){
		SocketError(hWnd,"SocketCxgʒmݒɎs܂B");
		return;
	}

	/* T[oɐڑ */
	if(ConnectServer(soc,serveraddr,Port) == FALSE){
		SocketError(hWnd,"T[oւ̐ڑɎs܂B");
		return;
	}

}

/*---------------------------------------------------
		HTTPNGXg𑗐M
---------------------------------------------------*/
void HTTPSendRequest(HWND hWnd)
{
	char SendBuf[BUFSIZE];			/* Mobt@ */
	char sendPath[BUFSIZE];

	/* HTTPNGXg̍쐬 */
	wsprintf(SendBuf,"GET %s HTTP/1.0\r\nHost: %s:%d\r\nUser-Agent: TsRename/0.0\r\n\r\n",Path,SvName,Port);
	/* f[^𑗐M */
	if(send(soc, SendBuf, lstrlen(SendBuf), 0) == SOCKET_ERROR){
		SocketError(hWnd,"MɎs܂B");
		return;
	}
	strcpy(OUT_BUF,"");
}

/*---------------------------------------------------
		f[^MĒ~ς
---------------------------------------------------*/
void HTTPRecvData(HWND hWnd)
{
	char RecvBuf[RECVSIZE];	/* Mobt@ */
	int buf_len;			/* MoCg */

	/* f[^M */
	buf_len = recv(soc, RecvBuf, RECVSIZE - 1, 0);
	if (buf_len == SOCKET_ERROR ){
		SocketError(hWnd,"MɎs܂B");
		return;
	}
	RecvBuf[buf_len] = '\0';		/* Mobt@̌NULLt */
	if((strlen(OUT_BUF) + buf_len) < OUTSIZE){
		strcat(OUT_BUF,RecvBuf);		/* obt@ɎM~ς */
	}
}

/*---------------------------------------------------
		T[oؒf
---------------------------------------------------*/
void HTTPClose(HWND hWnd)
{
	char RecvBuf[RECVSIZE];			/* Mobt@ */
	int buf_len;					/* MoCg */

	/* Mobt@Ƀf[^΂ׂĎM */
	while((buf_len = recv(soc, RecvBuf, RECVSIZE - 1, 0)) > 0 ){
		RecvBuf[buf_len] = '\0';	/* obt@̌NULLt */
		strcat(OUT_BUF,RecvBuf);
	}

	/* \Pbgj */
	SocketClose(hWnd);

	/* GfBbg{bNXɕ̕\s */
	ConvBuf(OUT_BUF);	/* 𐮌` */
	char* outsjis = (char*)utf8ToSjis(OUT_BUF);
	if(outsjis != NULL) {
		//SetDlgItemText(hWnd,IDC_EDIT2,outsjis);
		strcpy(OUT_BUF,outsjis);
		delete outsjis;
		bOut = TRUE;
	}
}
//===================================

BOOL m_bRenameSort[9] = {FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE};
int m_RenameSortSubItem = 8;

string& replace(string& str, const string sb, const string sa)
{
	string::size_type n, nb = 0;

	for(nb = 0;nb < str.size();nb++) {
		if(strncmp(((char*)(str.c_str()))+nb,sb.c_str(),sb.size()) == 0) {
			str.replace(nb,sb.size(),sa);
			nb += (sa.size()-1);
		}
		else if(_ismbblead(str[nb]))
			nb++;
	}
	//while ((n = str.find(sb,nb)) != string::npos)
	//{
	//	str.replace(n,sb.size(),sa);
	//	nb = n + sa.size();
	//}
	
	return str;
}


//̕ӂǉ
#include <direct.h>

extern bool reg_remove(string &input, const char *search);
extern string reg_search(string &input, const char *search);

const char *cmdchk(const char *s, const char *cmd) {
	if (strncmp(s, cmd, strlen(cmd))==0) {
		s+=strlen(cmd);
	}
	return s;
}
const char *searchchk(const char *s, char *buff, int size) {
	if (*s=='\'') {
		const char *qe = strchr(s+1, '\'');
		if (qe && (qe-s)<size) {
			strncpy(buff, s+1, qe-s-1);
			buff[qe-s-1] = 0;
			s=qe+1;
		}
	}
	return s;
}
void chomp(string &str) {
	while(true) {
		if (reg_remove(str, "\\s+$")) continue;
		if (reg_remove(str, "^\\s+")) continue;
		if (reg_remove(str, "(@)+$")) continue;
		if (reg_remove(str, "^(@)+")) continue;
		break;
	}
}

#define BUFLEN  127

/* ̔z */
struct {
    char *moji; /*  */
    char value; /* ʃoCgFʁ^ʃoCgFl */
} kanji[] = {
    {"Z", 0x00}, {"", 0x01}, {"", 0x02}, {"O", 0x03}, {"l", 0x04},
    {"", 0x05}, {"Z", 0x06}, {"", 0x07}, {"", 0x08}, {"", 0x09},
    {"\", 0x11}, {"S", 0x12}, {"", 0x13}, {"", 0x24}, {"", 0x28},
    {"", 0x00}, {"", 0x01}, {"", 0x01}, {"", 0x02}, {"", 0x02},
    {"Q", 0x03}, {"", 0x03}, {"", 0x04}, {"", 0x05}, {"", 0x06},
    {"J", 0x08}, {"", 0x09}, {"E", 0x11}, {"", 0x12}, {"", 0x12},
    {"", 0x13}, {"", 0x13}, {"", 0x24}, {"", 0x07},
};

char kanbuf[BUFLEN];   /* ͕ۑp̃obt@ */
int kanpc;             /* obt@̎Qƈʒu */

/* Pc珇Ɉꕶ */
int getvalue(void)
{
    int i;
    char k[3];
    static const int len = sizeof(kanji) / sizeof(kanji[0]);
    if (kanpc > 1) {
        k[2] = '\0'; k[1] = kanbuf[--kanpc]; k[0] = kanbuf[--kanpc];
        for (i = 0; i < len; i++) {
            if (strcmp(k, kanji[i].moji) == 0)
                return kanji[i].value;
        }
    }
    return -1;
}

/* 10  x  */
long _pow10(unsigned char x)
{
    long r = 1;
    while (x-- > 0) r *= 10;
    return r;
}

/* ϊ֐̖{ */
long kanji2long(void)
{
    long c, keta1 = 1, keta2 = 1, num1 = 0, num2 = 0;
    kanpc = strlen(kanbuf);
    while ((c = getvalue()) != -1) {
        if (c >= 0x00 && c <=0x09) {
            num1 += c * keta1 * keta2;
            keta1 *= 10; num2 = 0;
        } else {
            if (num2) num1 += keta1 * keta2;
            if (c & 0x10) {
                keta1 = _pow10(c & 0x0F);
                num2 = 1;
            } else if (c & 0x20) {
                keta1 = 1;
                keta2 = _pow10(c & 0x0F);
                num2 = 0;
            }
        }
    }
    if (num2) num1 += keta1 * keta2;
    return num1;    
}

const char *chkNumberString(const char* s,const char* top,string& stText,int* numbering)
{
	char tmp[256];
	s++;
	if ((s=searchchk(s, tmp, sizeof(tmp)))!=top+3) {
		string stNum = reg_search(stText, tmp);
		if(!stNum.empty()) {
			string re;
			re = reg_search(stNum,"[0-9]+");
			if(!re.empty()) {
				*numbering = atoi(re.c_str());
				return s;
			}
			re = reg_search(stNum,"[OPQRSTUVWX]+");
			if(!re.empty()) {
				char out[256];
				memset(out,0,256);
				::LCMapString(LOCALE_USER_DEFAULT, LCMAP_HALFWIDTH, re.c_str() , re.length() , out, 256); 
				*numbering = atoi(out);
				return s;
			}
			re = reg_search(stNum,"[ZOlܘZ\S疜ƎQޗJE虘ݎ]+");
			if(!re.empty()) {
				strcpy(kanbuf,re.c_str());
				*numbering = (int)kanji2long();
				return s;
			}
		}
	}
	return s;
}

bool tsreplace(string& stFileName,PROG_DATA *ppd, RENAME_DATA *prename,string& out,HWND hWnd) {
	// ^Cg͋ǖŌ

	string re;
	if(prename->type == 1)
		re = reg_search(ppd->stNameBack,prename->stFind.c_str());
	else if(prename->type == 2)
		re = reg_search(ppd->stChName,prename->stFindCh.c_str());
	else {
		re = reg_search(ppd->stNameBack,prename->stFind.c_str());
		if (re.length()>0)
			re = reg_search(ppd->stChName,prename->stFindCh.c_str());
	}
	if (re.length()==0)
		return false;

	if(!prename->stSyoboFind.empty()) {
		ppd->stSyoboTT.erase();
		ppd->stSyoboNB.erase();
		ppd->stSyoboSB.erase();
		ppd->stSyoboCH.erase();
		if(ppd->stSyoboLastSetting != prename->stSyoboFind) {
			ppd->stSyoboLastSetting = prename->stSyoboFind;
			ppd->stSyobo.erase();
			ppd->stSyoboName.erase();
			unsigned char* szNameUtf8 = SjisToutf8((char*)prename->stSyoboFind.c_str());
			if(szNameUtf8 != NULL) {
				char szNameUrl[512],szDateUrl[512];
				char szTmp[10];
				szNameUrl[0] = 0x00;
				szDateUrl[0] = 0x00;
				for(int i = 0;i < strlen((char*)szNameUtf8);i++) {
					sprintf(szTmp,"%%%02X",szNameUtf8[i]);
					strcat(szNameUrl,szTmp);
				}
				for(int i = 0;i < ppd->stY2_Date28.length();i++) {
					if(ppd->stY2_Date28[i] == '-')
						strcpy(szTmp,"%2F");
					else {
						szTmp[0] = ppd->stY2_Date28[i];
						szTmp[1] = 0x00;
					}
					strcat(szDateUrl,szTmp);
				}
				char buf[1024];
				sprintf(buf,"http://cal.syoboi.jp/find?kw=%s&sd=2&r=3&rd=%s-%s&v=0",szNameUrl,szDateUrl,szDateUrl);
				/* HTTPZbVJn */
				bOut = FALSE;
				HTTPStart(hWnd,buf);
				if(soc != -1) {
					delete szNameUtf8;
					int timeout = 200;
					MSG msg;
					while(!bOut &&  timeout > 0 && soc != -1) {
						timeout--;
						while (PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) {
							TranslateMessage( &msg );
							DispatchMessage ( &msg );
						}
						Sleep(100);
					}
					if(soc != -1){		/* ɒʐM̏ꍇ̓LZ */
						/* \Pbgj */
						SocketClose(hWnd);
					}
					if(bOut) {
						vector<SYOBO_DATA> syoboList;
						syoboList.clear();
						string stTmp = OUT_BUF;
						string stLine;
						while(!stTmp.empty()) {
							string::size_type find = stTmp.find("\r\n");
							if(find == string::npos) {
								stLine = stTmp;
								stTmp = "";
							}
							else {
								stLine = stTmp.substr(0,find);
								stTmp.erase(0,find + 2);
							}
							find = stLine.find("a href=\"/tid");
							if(find != string::npos) {
								replace(stLine,"&nbsp;","");
								SYOBO_DATA syobo;
								syobo.stSyobo = stLine;
								syobo.stDate = reg_search(stLine,"[0-9]+/[0-9]+/[0-9]+");
								syobo.stTime = reg_search(stLine,"[0-9]+:[0-9]+-[0-9]+:[0-9]+");
								string stName = stLine.substr(find);
								syobo.stName = reg_search(stName,"(?<=\">).+(?=</a>)");
								syobo.stCh = reg_search(stName,"(?<=<td>).+(?=</td>)");
								syoboList.push_back(syobo);
							}
						}
						time_t cmptime = 60*60*5;
						int sel = -1;
						if(syoboList.size() > 0) {
							for(int i = 0;i < syoboList.size();i++) {
								string stDate = syoboList[i].stDate;
								string stTime = syoboList[i].stTime;
								struct tm stm;
								stm.tm_year = atoi(stDate.c_str()) - 1900;
								stDate = stDate.substr(stDate.find("/")+1);
								stm.tm_mon = atoi(stDate.c_str()) - 1;
								stDate = stDate.substr(stDate.find("/")+1);
								stm.tm_mday = atoi(stDate.c_str());
								stm.tm_hour = atoi(stTime.c_str());
								stTime = stTime.substr(stTime.find(":")+1);
								stm.tm_min = atoi(stTime.c_str());
								stm.tm_sec = 0;
								time_t seltime = mktime(&stm);
								seltime = (time_t)abs((int)(seltime - ppd->stime));
								if(cmptime > seltime) {
									sel = i;
									cmptime = seltime;
								}
							}
							if(sel != -1) {
								ppd->stSyobo = syoboList[sel].stSyobo;
								ppd->stSyoboName = syoboList[sel].stName;
								ppd->stSyoboCHBack = syoboList[sel].stCh;
							}
						}
					}
				}
			}
		}
		if(!ppd->stSyobo.empty()) {
			if(prename->bSyoboTT)
				ppd->stSyoboTT = reg_search(ppd->stSyoboName,".+(?= #[0-9])");
			if(prename->bSyoboNB)
				ppd->stSyoboNB = reg_search(ppd->stSyoboName,"#[0-9]+(?= )");
			string top = reg_search(ppd->stSyoboName,".+#[0-9]+ ");
			if(prename->bSyoboSB)
				ppd->stSyoboSB = ppd->stSyoboName.substr(top.length());
			if(prename->bSyoboCH)
				ppd->stSyoboCH = ppd->stSyoboCHBack;
		}
	}
	char tmp[256];
	const char *s = (char*)prename->stRename.c_str();
	string pt[4], ps[4], pd[4], pf[4], pc[4];
	//24
	const char *wtext[] = {"","","","","","","y"};
	const char *wtexte[] = {"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
	struct tm tm24s, tm24e;
	memcpy(&tm24s, localtime((const time_t *)&ppd->stime), sizeof(struct tm));
	memcpy(&tm24e, localtime((const time_t *)&ppd->etime), sizeof(struct tm));
	//28
	int hour28s = tm24s.tm_hour, hour28e = tm24e.tm_hour;
	struct tm tm28s;
	if (hour28s<(28-24)) {
		//O
		time_t tmtmp = ppd->stime-24*60*60;
		memcpy(&tm28s, localtime((const time_t *)&tmtmp), sizeof(struct tm));
		hour28s+=24;
		hour28e+=24;
	} else {
		memcpy(&tm28s, &tm24s, sizeof(struct tm));
	}
	//ioO
	int numbering = 0;
	re = reg_search(prename->stRename, "\\@\\d{0,1}(nb|NB)");
	if (re.length()>0) {
		if(!ppd->stSyoboNB.empty()) {
			numbering = atoi(ppd->stSyoboNB.substr(1).c_str());
		}
		else {
			NUM_DATA num;
			for(int ni = 0;ni < prename->numList.size();ni++) {
				if(prename->numList[ni].stime <= ppd->stime)
					num = prename->numList[ni];
				else
					break;
			}
			if(num.stime != 0) {
				numbering = num.sno - 1;
				BOOL bNum = FALSE;
				int w;
				for(w = 0;w < 7;w++) {
					if(num.bWeekCheck[w]) {
						bNum = TRUE;
						break;
					}
				}
				if(bNum) {
					time_t stime = num.stime;
					while(stime <= ppd->stime) {
						struct tm* stTime;
						stTime = localtime( &stime);
						if(num.bWeekCheck[stTime->tm_wday])
							numbering++;
						stime += 60*60*24;
					}
				}
			}
		}
	}
	//
	while(s && *s) {
		if ( ((BYTE)*s>=0x80 && (BYTE)*s<=0x9f) || (BYTE)*s>=0xe0) {
			out+=*(s++);
			out+=*(s++);
			continue;
		}
		if (*s=='@') {
			s++;
			const char *top = s;
			if ((s = cmdchk(s, "TT"))!=top) {
				//@TT@c@ԑg^Cg
				if(ppd->stSyoboTT.empty())
					out+=ppd->stName;
				else
					out+=ppd->stSyoboTT;
			} else if ((s = cmdchk(s, "SB"))!=top) {
				//@SB@c@Tu^Cg iTu^Cgꍇ͕\܂)
				if(ppd->stSyoboSB.empty())
					out+=ppd->stCont;
				else
					out+=ppd->stSyoboSB;
			} else if ((s = cmdchk(s, "sb"))!=top) {
				//@sb@c@Tu^Cg iO̗]ȋ󔒔E펞gp)
				string strsb;
				if(ppd->stSyoboSB.empty())
					strsb=ppd->stCont;
				else
					strsb=ppd->stSyoboSB;
				chomp(strsb);
				out+=strsb;
			} else if ((s = cmdchk(s, "G1"))!=top) {
				//@G1@c@W區 iW區ڂꍇ͕\܂)
				out+=ppd->stGenre;
			} else if ((s = cmdchk(s, "G2"))!=top) {
				//@G2@c@W iWڂꍇ͕\܂)
				out+=ppd->stGenre2;
//ioO
			} else if ((s = cmdchk(s, "NB"))!=top) {
				//@NB@c@ioO
				sprintf(tmp, "#%d", numbering);
				out+=tmp;
			} else if ((s = cmdchk(s, "2NB"))!=top) {
				//@2NB c@ioO@(2j
				sprintf(tmp, "#%02d", numbering);
				out+=tmp;
			} else if ((s = cmdchk(s, "3NB"))!=top) {
				//@3NB c@ioO@(3j
				sprintf(tmp, "#%03d", numbering);
				out+=tmp;
			} else if ((s = cmdchk(s, "4NB"))!=top) {
				//@4NB c@ioO@(4j
				sprintf(tmp, "#%04d", numbering);
				out+=tmp;
			} else if ((s = cmdchk(s, "nb"))!=top) {
				//@nb@c@ioO@(#)
				sprintf(tmp, "%d", numbering);
				out+=tmp;
			} else if ((s = cmdchk(s, "2nb"))!=top) {
				//@2nb c@ioO@(#E2j
				sprintf(tmp, "%02d", numbering);
				out+=tmp;
			} else if ((s = cmdchk(s, "3nb"))!=top) {
				//@3nb c@ioO@(#E3j
				sprintf(tmp, "%03d", numbering);
				out+=tmp;
			} else if ((s = cmdchk(s, "4nb"))!=top) {
				//@4nb c@ioO@(#E4j
				sprintf(tmp, "%04d", numbering);
				out+=tmp;
//t
			} else if ((s = cmdchk(s, "CH"))!=top) {
				//@CH@c@ǖ iIǂĂȂꍇ͕\܂)
				if(ppd->stSyoboCH.empty())
					out+=ppd->stChName;
				else
					out+=ppd->stSyoboCH;
			} else if ((s = cmdchk(s, "YY"))!=top) {
				//@YY@c@QSԕ\LEN
				sprintf(tmp, "%04d", 1900+tm24s.tm_year);
				out+=tmp;
			} else if ((s = cmdchk(s, "2YY"))!=top) {
				//@2YY c@QSԕ\LEN@(2j
				sprintf(tmp, "%02d", (tm24s.tm_year)%100);
				out+=tmp;
			} else if ((s = cmdchk(s, "MM"))!=top) {
				//@MM@c@QSԕ\LE
				sprintf(tmp, "%02d", tm24s.tm_mon+1);
				out+=tmp;
			} else if ((s = cmdchk(s, "DD"))!=top) {
				//@DD@c@QSԕ\LE
				sprintf(tmp, "%02d", tm24s.tm_mday);
				out+=tmp;
			} else if ((s = cmdchk(s, "SH"))!=top) {
				//@SH@c@QSԕ\LEJnԁE
				sprintf(tmp, "%02d", tm24s.tm_hour);
				out+=tmp;
			} else if ((s = cmdchk(s, "SM"))!=top) {
				//@SM@c@QSԕ\LEJnԁE
				sprintf(tmp, "%02d", tm24s.tm_min);
				out+=tmp;
			} else if ((s = cmdchk(s, "SS"))!=top) {
				//@SS@c@QSԕ\LEJnԁEb
				sprintf(tmp, "%02d", tm24s.tm_sec);
				out+=tmp;
			} else if ((s = cmdchk(s, "WK"))!=top) {
				//@WK@c@QSԕ\LEJnԁEj
				out+=wtext[tm24s.tm_wday];
			} else if ((s = cmdchk(s, "WE"))!=top) {
				//@WE@c@QSԕ\LEJnԁEjEp\L
				out+=wtexte[tm24s.tm_wday];
			} else if ((s = cmdchk(s, "EH"))!=top) {
				//@EH@c@QSԕ\LEIԁE
				sprintf(tmp, "%02d", tm24e.tm_hour);
				out+=tmp;
			} else if ((s = cmdchk(s, "EM"))!=top) {
				//@EM@c@QSԕ\LEIԁE
				sprintf(tmp, "%02d", tm24e.tm_min);
				out+=tmp;
			} else if ((s = cmdchk(s, "ES"))!=top) {
				//@ES@c@QSԕ\LEIԁEb
				sprintf(tmp, "%02d", tm24e.tm_sec);
				out+=tmp;
			} else if ((s = cmdchk(s, "yy"))!=top) {
				//@yy@c@QWԕ\LEN
				sprintf(tmp, "%04d", 1900+tm28s.tm_year);
				out+=tmp;
			} else if ((s = cmdchk(s, "2yy"))!=top) {
				//[tsrenamec]g
				//@2yy@c@QWԕ\LEN@(2j
				sprintf(tmp, "%02d", (tm28s.tm_year)%100);
				out+=tmp;
			} else if ((s = cmdchk(s, "mm"))!=top) {
				//@mm@c@QWԕ\LE
				sprintf(tmp, "%02d", tm28s.tm_mon+1);
				out+=tmp;
			} else if ((s = cmdchk(s, "dd"))!=top) {
				//@dd@c@QWԕ\LE
				sprintf(tmp, "%02d", tm28s.tm_mday);
				out+=tmp;
			} else if ((s = cmdchk(s, "sh"))!=top) {
				//@sh@c@QWԕ\LEJnԁE
				sprintf(tmp, "%02d", hour28s);
				out+=tmp;
			} else if ((s = cmdchk(s, "sm"))!=top) {
				//@sm@c@QWԕ\LEJnԁE
				sprintf(tmp, "%02d", tm24s.tm_min);
				out+=tmp;
			} else if ((s = cmdchk(s, "ss"))!=top) {
				//@ss@c@QWԕ\LEJnԁEb
				sprintf(tmp, "%02d", tm24s.tm_sec);
				out+=tmp;
			} else if ((s = cmdchk(s, "wk"))!=top) {
				//@wk@c@QWԕ\LEJnԁEj
				out+=wtext[tm28s.tm_wday];
			} else if ((s = cmdchk(s, "we"))!=top) {
				//@we@c@QWԕ\LEJnԁEjEp\L
				out+=wtexte[tm28s.tm_wday];
			} else if ((s = cmdchk(s, "eh"))!=top) {
				//@eh@c@QWԕ\LEIԁE
				sprintf(tmp, "%02d", hour28e);
				out+=tmp;
			} else if ((s = cmdchk(s, "em"))!=top) {
				//@em@c@QWԕ\LEIԁE
				sprintf(tmp, "%02d", tm24e.tm_min);
				out+=tmp;
			} else if ((s = cmdchk(s, "es"))!=top) {
				//@es@c@QWԕ\LEIԁEb
				sprintf(tmp, "%02d", tm24e.tm_sec);
				out+=tmp;
//t܂
			} else if ((s = cmdchk(s, "MST"))!=top) {
				//MST c@ԑg^CgɁuvň͂܂Ă镔ԑge(Tu^Cg)ֈړ
				string::size_type ks, ke;
				if ((ks=ppd->stName.find("u"))!=string::npos) {
					if ((ke=ppd->stName.find("v", ks))!=string::npos) {
						ppd->stCont = ppd->stName.substr(ks, ke-ks+2);
						ppd->stName.erase(ks, ke-ks+2);
					}
				}
			} else if ((s = cmdchk(s, "C"))!=top) {
				//@C'xxx' c@ԑg^Cg"xxx"Jbg(K\)
				if ((s=searchchk(s, tmp, sizeof(tmp)))!=top+1) {
					reg_remove(ppd->stName, tmp);
				}
			} else if ((s = cmdchk(s, "NT"))!=top) {
				//@NT1'xxx'@`@@NT4'xxx'@c@^Cg'xxx'Ŏw肳ꂽK\Ń}b`Os@PT1`@PT4Ɋi[
				if (*s>='1' && *s<='4') {
					int idx = *(s++)-'1';
					if ((s=searchchk(s, tmp, sizeof(tmp)))!=top+3) {
						pt[idx] = reg_search(ppd->stNameBack, tmp);
					}
				}
				else if(*s == 'N') {
					s = chkNumberString(s,top,ppd->stNameBack,&numbering);
				}
			} else if ((s = cmdchk(s, "NS"))!=top) {
				//@NS1'xxx'@`@@NS4'xxx'@c@Tu^Cg'xxx'Ŏw肳ꂽK\Ń}b`Os@PS1`@PS4Ɋi[
				string stCont = ppd->stCont;
				replace(stCont,"\r","\r\n");
				if (*s>='1' && *s<='4') {
					int idx = *(s++)-'1';
					if ((s=searchchk(s, tmp, sizeof(tmp)))!=top+3) {
						ps[idx] = reg_search(stCont, tmp);
						//replace(ps[idx],"\r","");
						//replace(ps[idx],"\n","");
					}
				}
				else if(*s == 'N') {
					s = chkNumberString(s,top,stCont,&numbering);
				}
			} else if ((s = cmdchk(s, "ND"))!=top) {
				//[tsrenamec]g
				//@ND1'xxx'@`@@NS4'xxx'@c@ڍ׏񂩂'xxx'Ŏw肳ꂽK\Ń}b`Os@PS1`@PS4Ɋi[
				string stDetails = ppd->stDetails;
				replace(stDetails,"\r","\r\n");
				if (*s>='1' && *s<='4') {
					int idx = *(s++)-'1';
					if ((s=searchchk(s, tmp, sizeof(tmp)))!=top+3) {
						pd[idx] = reg_search(stDetails, tmp);
						//replace(pd[idx],"\r","");
						//replace(pd[idx],"\n","");
					}
				}
				else if(*s == 'N') {
					s = chkNumberString(s,top,stDetails,&numbering);
				}
			} else if ((s = cmdchk(s, "NF"))!=top) {
				//@NF1'xxx'@`@@NF4'xxx'@c@t@C'xxx'Ŏw肳ꂽK\Ń}b`Os@PF1`@PF4Ɋi[
				if (*s>='1' && *s<='4') {
					int idx = *(s++)-'1';
					if ((s=searchchk(s, tmp, sizeof(tmp)))!=top+3) {
						pf[idx] = reg_search(stFileName, tmp);
					}
				}
				else if(*s == 'N') {
					s = chkNumberString(s,top,stFileName,&numbering);
				}
			} else if ((s = cmdchk(s, "NC"))!=top) {
				//@NC1'xxx'@`@@NC4'xxx'@c@ڂJ_[Ŏ擾񂩂'xxx'Ŏw肳ꂽK\Ń}b`Os@PC1`@PC4Ɋi[
				if (*s>='1' && *s<='4') {
					int idx = *(s++)-'1';
					if ((s=searchchk(s, tmp, sizeof(tmp)))!=top+3) {
						pc[idx] = reg_search(ppd->stSyoboName, tmp);
					}
				}
			} else if ((s = cmdchk(s, "PT"))!=top) {
				//@PT1@`@@PT4@c@@NT1`@NT4̃}b`O
				if (*s>='1' && *s<='4') {
					out+=pt[*(s++)-'1'];
				}
			} else if ((s = cmdchk(s, "PS"))!=top) {
				//@PS1@`@@PS4@c@@NS1`@NS4̃}b`O
				if (*s>='1' && *s<='4') {
					out+=ps[*(s++)-'1'];
				}
			} else if ((s = cmdchk(s, "PD"))!=top) {
				//[tsrenamec]g
				//@PD1@`@@PD4@c@@ND1`@ND4̃}b`O
				if (*s>='1' && *s<='4') {
					out+=pd[*(s++)-'1'];
				}
			} else if ((s = cmdchk(s, "PF"))!=top) {
				//[tsrenamec]g
				//@PF1@`@@PF4@c@@NF1`@NF4̃}b`O
				if (*s>='1' && *s<='4') {
					out+=pf[*(s++)-'1'];
				}
			} else if ((s = cmdchk(s, "PC"))!=top) {
				//[tsrenamec]g
				//@PC1@`@@PC4@c@@NC1`@NC4̃}b`O
				if (*s>='1' && *s<='4') {
					out+=pc[*(s++)-'1'];
				}
			} else {
				out+="@";	//nYR}h
			}
		} else {
			out+=*(s++);
		}
	}
	//printf("%s", out.c_str());
	return true;
}
//*************************************************

int CALLBACK RenameCompProc(LPARAM lp1, LPARAM lp2, LPARAM lp3)
{
	vector<FILE_DATA>::iterator fit1 = m_FileList.begin() + (int)lp1;
	vector<FILE_DATA>::iterator fit2 = m_FileList.begin() + (int)lp2;
	int sub = (int)lp3;
	BOOL bSort = m_bRenameSort[sub];
	char szName1[1024],szName2[1024];
	int ret = 0;	

	switch(sub) {
		case 0:
			strcpy(szName1,(char*)fit1->stFileName.c_str());
			strcpy(szName2,(char*)fit2->stFileName.c_str());
			ret = strcmp(szName1,szName2);
			break;
		case 1:
			strcpy(szName1,(char*)fit1->stNewName.c_str());
			strcpy(szName2,(char*)fit2->stNewName.c_str());
			ret = strcmp(szName1,szName2);
			break;
		case 2:
			strcpy(szName1,(char*)fit1->progList[fit1->nSelNo].stName.c_str());
			strcpy(szName2,(char*)fit2->progList[fit2->nSelNo].stName.c_str());
			ret = strcmp(szName1,szName2);
			break;
		case 3:
			strcpy(szName1,(char*)fit1->progList[fit1->nSelNo].stChName.c_str());
			strcpy(szName2,(char*)fit2->progList[fit2->nSelNo].stChName.c_str());
			ret = strcmp(szName1,szName2);
			break;
		case 4:
			wsprintf(szName1,"%s %s",(char*)fit1->progList[fit1->nSelNo].stDate.c_str(),(char*)fit1->progList[fit1->nSelNo].stSTime.c_str());
			wsprintf(szName2,"%s %s",(char*)fit2->progList[fit2->nSelNo].stDate.c_str(),(char*)fit2->progList[fit2->nSelNo].stSTime.c_str());
			ret = strcmp(szName1,szName2);
			break;
		case 5:
			strcpy(szName1,(char*)fit1->progList[fit1->nSelNo].stCont.c_str());
			strcpy(szName2,(char*)fit2->progList[fit2->nSelNo].stCont.c_str());
			ret = strcmp(szName1,szName2);
			break;
		case 6:
			strcpy(szName1,(char*)fit1->progList[fit1->nSelNo].stAv.c_str());
			strcpy(szName2,(char*)fit2->progList[fit2->nSelNo].stAv.c_str());
			ret = strcmp(szName1,szName2);
			break;
		case 7:
			strcpy(szName1,(char*)fit1->progList[fit1->nSelNo].stGenre0.c_str());
			strcpy(szName2,(char*)fit2->progList[fit2->nSelNo].stGenre0.c_str());
			ret = strcmp(szName1,szName2);
			break;
		case 8:
			ret = lp1-lp2;
			break;
	}
	if(ret == 1 && !bSort)
		ret = -1;
	else if(ret == -1 && !bSort)
		ret = 1;
	return ret;
}

void ProgSel(HWND hWnd,int itemNo)
{
	HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
	LV_ITEM item;
	item.mask = LVIF_PARAM;
	item.iItem = itemNo;
	item.iSubItem = 0;
	ListView_GetItem(hList,&item);
	if(m_FileList[item.lParam].progList[0].stime > 0) {
		SetForegroundWindow(hWnd);	//EBhEtHAOEhɎĂ܂B
		SetFocus(hWnd);	//ȂƁAj[ȂȂ܂B
		HMENU hSubmenu = CreatePopupMenu();
		MENUITEMINFO mi;
		memset(&mi, 0, sizeof(MENUITEMINFO));
		mi.cbSize = sizeof(MENUITEMINFO);
		mi.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
		mi.fType = MFT_STRING;
		mi.fState = MFS_ENABLED;
		char szData[1024];
		int i;
		for(i = 0;i < m_FileList[item.lParam].progList.size();i++) {
			mi.fState = MFS_ENABLED;
			mi.wID = IDM_TSR_NAME_SELECT + i;
			//if(i == m_FileList[item.lParam].nSelNo)
			//	mi.fState |= MFS_CHECKED;
			wsprintf(szData,"%s [%s](&%d)",(char*)m_FileList[item.lParam].progList[i].stName.c_str(),(char*)m_FileList[item.lParam].progList[i].stChName.c_str(),i+1);
			mi.dwTypeData = szData;
			InsertMenuItem(hSubmenu,i,FALSE,&mi);
		}
		CheckMenuRadioItem( hSubmenu, IDM_TSR_NAME_SELECT, IDM_TSR_NAME_SELECT + (i-1),LOWORD( IDM_TSR_NAME_SELECT + m_FileList[item.lParam].nSelNo ),MF_BYCOMMAND );
		InsertMenu(hSubmenu,i++,MF_SEPARATOR,0,NULL);
		mi.fState = MFS_ENABLED;
		mi.wID = IDM_TSR_NAME_EDIT;
		mi.dwTypeData = "ԑgҏW(&E)";
		InsertMenuItem(hSubmenu,i++,FALSE,&mi);
		RECT btnrct;
		ListView_GetSubItemRect(hList,itemNo,2,LVIR_LABEL,&btnrct);
		POINT pos;
		pos.x = btnrct.left;
		pos.y = btnrct.bottom;
		ClientToScreen(hList,&pos);
		m_nSelectItemNo = item.lParam;
		m_nSelectItemNoItem = itemNo;
		m_nSelectItemPos.x = btnrct.left;
		m_nSelectItemPos.y = btnrct.top;
		ClientToScreen(hList,&m_nSelectItemPos);
		//GetCursorPos(&pos);
		TrackPopupMenu(hSubmenu, TPM_LEFTALIGN |TPM_TOPALIGN |TPM_RIGHTBUTTON | TPM_LEFTBUTTON,pos.x,pos.y,0,hWnd,NULL);
		DestroyMenu(hSubmenu);
		PostMessage(hWnd, WM_NULL ,0,0);	//ȂƁAQxڂ̃j[Ⴂ܂B
	}
}

void ContDisp(HWND hWnd,int nItemNo)
{
	HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
	LV_ITEM item;
	item.mask = LVIF_PARAM;
	item.iItem = nItemNo;
	item.iSubItem = 0;
	ListView_GetItem(hList,&item);

	char szData[1024];
	string stCont = m_FileList[item.lParam].progList[m_FileList[item.lParam].nSelNo].stCont;
	if(stCont.empty())
		return;
	string stDetails = m_FileList[item.lParam].progList[m_FileList[item.lParam].nSelNo].stDetails;
	SetForegroundWindow(hWnd);	//EBhEtHAOEhɎĂ܂B
	SetFocus(hWnd);	//ȂƁAj[ȂȂ܂B
	HMENU hSubmenu = CreatePopupMenu();
	MENUITEMINFO mi;
	int itemNo = 0;
	memset(&mi, 0, sizeof(MENUITEMINFO));
	mi.cbSize = sizeof(MENUITEMINFO);
	mi.fMask = MIIM_TYPE;
	mi.fType = MFT_STRING;
	const char *str0 = stCont.c_str();
	const char *strlast = stCont.c_str() + strlen(stCont.c_str());
	if(*(strlast-1) == 0x0d)
		strlast--;
	while(str0 < strlast) {
		const char *str = strstr(str0,"\r");
		if(str == NULL) {
			str = strlast;
		}
		if(str-str0 > 66) {
			int is;
			for(is = 0;is < str-str0;is++) {
				if(_ismbblead(*(str0+is)))
					is++;
				if(is >= 60)
					break;
			}
			str = str0 + is - 1;
			strncpy(szData,str0,str-str0);
			szData[str-str0] = 0x00;
			mi.dwTypeData = szData;
			InsertMenuItem(hSubmenu,itemNo++,FALSE,&mi);
			str0 = str;
		}
		else {
			strncpy(szData,str0,str-str0);
			szData[str-str0] = 0x00;
			mi.dwTypeData = szData;
			InsertMenuItem(hSubmenu,itemNo++,FALSE,&mi);
			str0 = str+1;
		}
	}
	if(!stDetails.empty()) {
		const char *str0 = stDetails.c_str();
		const char *strlast = stDetails.c_str() + strlen(stDetails.c_str());
		if(*(strlast-1) == 0x0d)
			strlast--;
		while(str0 < strlast) {
			const char *str = strstr(str0,"\r");
			if(str == NULL) {
				str = strlast;
			}
			if(str-str0 > 66) {
				int is;
				for(is = 0;is < str-str0;is++) {
					if(_ismbblead(*(str0+is)))
						is++;
					if(is >= 60)
						break;
				}
				str = str0 + is - 1;
				strncpy(szData,str0,str-str0);
				szData[str-str0] = 0x00;
				mi.dwTypeData = szData;
				InsertMenuItem(hSubmenu,itemNo++,FALSE,&mi);
				str0 = str;
			}
			else {
				strncpy(szData,str0,str-str0);
				szData[str-str0] = 0x00;
				mi.dwTypeData = szData;
				InsertMenuItem(hSubmenu,itemNo++,FALSE,&mi);
				str0 = str+1;
			}
		}
	}
	RECT btnrct;
	ListView_GetSubItemRect(hList,nItemNo,5,LVIR_LABEL,&btnrct);
	POINT pos;
	pos.x = btnrct.left;
	pos.y = btnrct.bottom;
	ClientToScreen(hList,&pos);
	m_nSelectItemNo = item.lParam;
	m_nSelectItemNoItem = nItemNo;
	//GetCursorPos(&pos);
	TrackPopupMenu(hSubmenu, TPM_LEFTALIGN |TPM_TOPALIGN |TPM_RIGHTBUTTON | TPM_LEFTBUTTON,pos.x,pos.y,0,hWnd,NULL);
	DestroyMenu(hSubmenu);
	PostMessage(hWnd, WM_NULL ,0,0);	//ȂƁAQxڂ̃j[Ⴂ܂B
}

LRESULT CALLBACK NameEditDlgProc(HWND hWnd,UINT meg,WPARAM wp,LPARAM lp)
{
    switch ( meg )
    {
	case WM_INITDIALOG:
		{
			SetWindowPos(hWnd,NULL,m_nSelectItemPos.x-14,m_nSelectItemPos.y-16-GetSystemMetrics(SM_CYCAPTION),0,0,SWP_NOSIZE|SWP_NOZORDER);
			SetDlgItemText(hWnd,IDC_EDT_NAME,(char*)m_stEdtName.c_str());
			SetFocus(GetDlgItem(hWnd,IDC_EDT_NAME));
			SendMessage(GetDlgItem(hWnd,IDC_EDT_NAME),EM_SETSEL,65535,65535);

			replace(m_stCont,"\r","");
			replace(m_stCont,"\n","");
		}
		break;
	case WM_COMMAND:
		if(HIWORD(wp) == 0x00) {
			switch ( LOWORD(wp) )
			{
			case IDC_PST_CONT:
				{
					WPARAM start;
					SendMessage(GetDlgItem(hWnd,IDC_EDT_NAME),EM_GETSEL,(WPARAM)&start,0);
					SendMessage(GetDlgItem(hWnd,IDC_EDT_NAME),EM_REPLACESEL, 0, (LPARAM)m_stCont.c_str());
					SendMessage(GetDlgItem(hWnd,IDC_EDT_NAME),EM_SETSEL,start,start);
					SetFocus(GetDlgItem(hWnd,IDC_EDT_NAME));
				}
				break;
			case IDOK:
				{
					char sztmp[256];
					GetDlgItemText(hWnd,IDC_EDT_NAME,sztmp,256);
					m_stEdtName = sztmp;
					::EndDialog(hWnd,IDOK);
				}
				break;
			case IDCANCEL:
				::EndDialog(hWnd,IDCANCEL);
				break;
			}
		}
		break;
	}
    return 0;
}

LRESULT CALLBACK SetupDlgProc(HWND hWnd,UINT meg,WPARAM wp,LPARAM lp)
{
    switch ( meg )
    {
	case WM_INITDIALOG:
		{
			char szData[100];

			wsprintf(szData,"%d",m_nReadStartPos);
			SetDlgItemText(hWnd,IDC_STARTPOINT,szData);
			wsprintf(szData,"%d",m_nReadSize);
			SetDlgItemText(hWnd,IDC_READSIZE,szData);
		}
		break;
	case WM_COMMAND:
		if(HIWORD(wp) == 0x00) {
			switch ( LOWORD(wp) )
			{
			case IDOK:
				{
					char szData[100];
					GetDlgItemText(hWnd,IDC_STARTPOINT,szData,100);
					int pos = atoi(szData);
					if(pos < 0 || pos > 100) {
						MessageBox(hWnd,"1`100Ŏw肵ĂB","ݒ",MB_OK);
						break;
					}
					m_nReadStartPos = pos;
					GetDlgItemText(hWnd,IDC_READSIZE,szData,100);
					m_nReadSize = atoi(szData);
					::EndDialog(hWnd,IDOK);
				}
				break;
			case IDCANCEL:
				::EndDialog(hWnd,IDCANCEL);
				break;
			}
		}
		break;
	}
    return 0;
}

RENAME_DATA m_editRenameData;
vector<RENAME_DATA> m_editRenameList;

void UpdateRenameDataList(void)
{
	char szItem[100],szKey[100],szData[1024];
	int i,recount = 0;
	RENAME_DATA redata;
	for(i = 0;i < m_RenameList.size();i++) {
		sprintf(szItem,"TvRockReNameSet%06d",i);
		WritePrivateProfileString(szItem,"FindText",NULL,m_szIniPath);
		WritePrivateProfileString(szItem,"FindTextCh",NULL,m_szIniPath);
		WritePrivateProfileString(szItem,"FindType",NULL,m_szIniPath);
		WritePrivateProfileString(szItem,"RenameText",NULL,m_szIniPath);
		WritePrivateProfileString(szItem,"SyoboFind",NULL,m_szIniPath);
		WritePrivateProfileString(szItem,"SyoboTT",NULL,m_szIniPath);
		WritePrivateProfileString(szItem,"SyoboNB",NULL,m_szIniPath);
		WritePrivateProfileString(szItem,"SyoboSB",NULL,m_szIniPath);
		WritePrivateProfileString(szItem,"SyoboCH",NULL,m_szIniPath);
		for(int ni = 0;ni < m_RenameList[i].numList.size();ni++) {
			if(ni == 0)
				strcpy(szKey,"StartTime");
			else
				sprintf(szKey,"StartTime%06d",ni);
			WritePrivateProfileString(szItem,szKey,NULL,m_szIniPath);
			if(ni == 0)
				strcpy(szKey,"StartNo");
			else
				sprintf(szKey,"StartNo%06d",ni);
			WritePrivateProfileString(szItem,szKey,NULL,m_szIniPath);
			for(int w = 0;w < 7;w++) {
				if(ni == 0)
					sprintf(szKey,"WeekCheck%d",w);
				else
					sprintf(szKey,"WeekCheck%06d_%d",ni,w);
				WritePrivateProfileString(szItem,szKey,NULL,m_szIniPath);
			}
		}
	}
	m_RenameList = m_editRenameList;
	for(i = 0;i < m_RenameList.size();i++) {
		sprintf(szItem,"TvRockReNameSet%06d",i);
		WritePrivateProfileString(szItem,"FindText",m_RenameList[i].stFind.c_str(),m_szIniPath);
		WritePrivateProfileString(szItem,"FindTextCh",m_RenameList[i].stFindCh.c_str(),m_szIniPath);
		sprintf(szData,"%d",m_RenameList[i].type);
		WritePrivateProfileString(szItem,"FindType",szData,m_szIniPath);
		WritePrivateProfileString(szItem,"RenameText",m_RenameList[i].stRename.c_str(),m_szIniPath);
		WritePrivateProfileString(szItem,"SyoboFind",m_RenameList[i].stSyoboFind.c_str(),m_szIniPath);
		sprintf(szData,"%d",m_RenameList[i].bSyoboTT);
		WritePrivateProfileString(szItem,"SyoboTT",szData,m_szIniPath);
		sprintf(szData,"%d",m_RenameList[i].bSyoboNB);
		WritePrivateProfileString(szItem,"SyoboNB",szData,m_szIniPath);
		sprintf(szData,"%d",m_RenameList[i].bSyoboSB);
		WritePrivateProfileString(szItem,"SyoboSB",szData,m_szIniPath);
		sprintf(szData,"%d",m_RenameList[i].bSyoboCH);
		WritePrivateProfileString(szItem,"SyoboCH",szData,m_szIniPath);
		for(int ni = 0;ni < m_RenameList[i].numList.size();ni++) {
			if(ni == 0)
				strcpy(szKey,"StartTime");
			else
				sprintf(szKey,"StartTime%06d",ni);
			sprintf(szData,"%I64d",m_RenameList[i].numList[ni].stime);
			WritePrivateProfileString(szItem,szKey,szData,m_szIniPath);
			if(ni == 0)
				strcpy(szKey,"StartNo");
			else
				sprintf(szKey,"StartNo%06d",ni);
			sprintf(szData,"%d",m_RenameList[i].numList[ni].sno);
			WritePrivateProfileString(szItem,szKey,szData,m_szIniPath);
			for(int w = 0;w < 7;w++) {
				if(ni == 0)
					sprintf(szKey,"WeekCheck%d",w);
				else
					sprintf(szKey,"WeekCheck%06d_%d",ni,w);
				sprintf(szData,"%d",m_RenameList[i].numList[ni].bWeekCheck[w]);
				WritePrivateProfileString(szItem,szKey,szData,m_szIniPath);
			}
		}
	}
}

int SetListViewRenameData(HWND hWnd,RENAME_DATA& renameData,int itemNo)
{
	char szDmy[2048];
	HWND hList = GetDlgItem(hWnd,IDC_TVROCK_LIST);
	LV_ITEM item;
	item.mask = LVIF_TEXT;
	item.pszText = m_szType[renameData.type];
	item.iItem = itemNo;
	item.iSubItem = 0;
	int insitem = ListView_InsertItem(hList,&item);
	if(renameData.type == 1)
		strcpy(szDmy,renameData.stFind.c_str());
	else if(renameData.type == 2)
		strcpy(szDmy,renameData.stFindCh.c_str());
	else
		sprintf(szDmy,"%s,%s",renameData.stFind.c_str(),renameData.stFindCh.c_str());

	item.pszText = szDmy;
	item.iItem = insitem;
	item.iSubItem = 1;
	ListView_SetItem(hList, &item);
	item.pszText = (char*)renameData.stRename.c_str();
	item.iItem = insitem;
	item.iSubItem = 2;
	ListView_SetItem(hList, &item);
	item.pszText = (char*)renameData.stSyoboFind.c_str();
	item.iItem = insitem;
	item.iSubItem = 3;
	ListView_SetItem(hList, &item);

	char* szwday[7] = {"","","","","","","y"};
	char szData[100];
	struct tm* ntm;

	if(renameData.numList.size() > 0) {
		ntm = localtime(&renameData.numList[0].stime);
		sprintf(szData,"%02d/%02d/%02d(%s) #%d ",ntm->tm_year+1900,ntm->tm_mon+1,ntm->tm_mday,szwday[ntm->tm_wday],renameData.numList[0].sno);
		for(int w = 0;w < 7;w++) {
			if(renameData.numList[0].bWeekCheck[w])
				strcat(szData,szwday[w]);
		}
		item.pszText = szData;
		item.iItem = insitem;
		item.iSubItem = 4;
		ListView_SetItem(hList, &item);
	}

	return insitem;
}

void InserRenameData(HWND hWnd,vector<RENAME_DATA>* prenameList ,RENAME_DATA* prenameData)
{
	int ipos = -1;
	for(int ri = 0;ri < prenameList->size();ri++) {
		if((*prenameList)[ri].type == prenameData->type) {
			if(prenameData->type != 2) {
				if((*prenameList)[ri].stFind >= prenameData->stFind) {
					ipos = ri;
					break;
				}
			}
			else {
				if((*prenameList)[ri].stFindCh >= prenameData->stFindCh) {
					ipos = ri;
					break;
				}
			}
		}
		else if((*prenameList)[ri].type > prenameData->type) {
			ipos = ri;
			break;
		}
	}
	if(ipos != -1) {
		vector<RENAME_DATA>::iterator rit = prenameList->begin();
		prenameList->insert(rit+ipos,*prenameData);
	}
	else {
		prenameList->push_back(*prenameData);
		ipos = prenameList->size() - 1;
	}

	if(hWnd != NULL)
		SetListViewRenameData(hWnd,*prenameData,ipos);
}

LRESULT CALLBACK TvRockReNameDlgProc(HWND hWnd,UINT meg,WPARAM wp,LPARAM lp)
{
    switch ( meg )
    {
	case WM_INITDIALOG:
		{
			HWND hList = GetDlgItem(hWnd,IDC_TVROCK_LIST);
			DWORD dwStyle;
			dwStyle = ListView_GetExtendedListViewStyle(hList);
			dwStyle |= LVS_EX_FULLROWSELECT;/*| LVS_EX_GRIDLINES*/;
			ListView_SetExtendedListViewStyle(hList, dwStyle);

			LV_COLUMN lvcol;
			lvcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
			lvcol.fmt = LVCFMT_LEFT;
			lvcol.cx = GetPrivateProfileInt("TvRockReNameDlg","TYPEW",60,m_szIniPath);
			lvcol.pszText = "^Cv";
			lvcol.iSubItem = 0;
			ListView_InsertColumn(hList, 0, &lvcol);

			lvcol.cx = GetPrivateProfileInt("TvRockReNameDlg","FINDW",140,m_szIniPath);
			lvcol.pszText = "";
			lvcol.iSubItem = 1;
			ListView_InsertColumn(hList, 1, &lvcol);

			lvcol.cx = GetPrivateProfileInt("TvRockReNameDlg","RENAMEW",300,m_szIniPath);
			lvcol.pszText = "u";
			lvcol.iSubItem = 2;
			ListView_InsertColumn(hList, 2, &lvcol);

			lvcol.cx = GetPrivateProfileInt("TvRockReNameDlg","SYOBOW",140,m_szIniPath);
			lvcol.pszText = "ڂް";
			lvcol.iSubItem = 3;
			ListView_InsertColumn(hList, 3, &lvcol);

			lvcol.cx = GetPrivateProfileInt("TvRockReNameDlg","NUMBERW",200,m_szIniPath);
			lvcol.pszText = "ioO";
			lvcol.iSubItem = 4;
			ListView_InsertColumn(hList, 4, &lvcol);
			m_editRenameList = m_RenameList;

			for(int i = 0;i < m_editRenameList.size();i++) {
				SetListViewRenameData(hWnd,m_editRenameList[i],i);
			}
			SetFocus(GetDlgItem(hWnd,IDC_FIND_TEXT));
		}
		break;
	case WM_NOTIFY:
		{
			NMHDR* pnmhdr = (LPNMHDR)lp;
			LPNMLVCUSTOMDRAW lplvcd;
			if(pnmhdr->idFrom == IDC_TVROCK_LIST)
			{
				switch(pnmhdr->code)
				{
					case NM_DBLCLK:
						PostMessage(hWnd,WM_COMMAND,IDC_TVROCK_EDIT,0l);
						break;
				}
			}
		}
		break;
	case WM_COMMAND:
		if(HIWORD(wp) == 0x00) {
			switch ( LOWORD(wp) )
			{
			case IDC_TVROCK_INS:
				{
					m_editRenameData.Reset();
					if(DialogBox(hInst,MAKEINTRESOURCE(IDD_TVROCK_SETUP),hWnd,(DLGPROC)TvRockSetupDlgProc) == IDOK) {
						InserRenameData(hWnd,&m_editRenameList,&m_editRenameData);
					}
				}
				break;
			case IDC_TVROCK_EDIT:
				{
					HWND hList = GetDlgItem(hWnd,IDC_TVROCK_LIST);
					int selitem = ListView_GetNextItem(hList,-1,LVNI_ALL | LVNI_SELECTED);
					if(selitem != -1) {
						m_editRenameData = m_editRenameList[selitem];
						if(DialogBox(hInst,MAKEINTRESOURCE(IDD_TVROCK_SETUP),hWnd,(DLGPROC)TvRockSetupDlgProc) == IDOK) {
							ListView_DeleteItem(hList,selitem);
							vector<RENAME_DATA>::iterator rit = m_editRenameList.begin();
							m_editRenameList.erase(rit+selitem);
							InserRenameData(hWnd,&m_editRenameList,&m_editRenameData);
						}
					}
				}
				break;
			case IDC_TVROCK_DEL:
				{
					HWND hList = GetDlgItem(hWnd,IDC_TVROCK_LIST);
					LV_ITEM item;
					int selitem = -1;
					while((selitem = ListView_GetNextItem(hList,-1,LVNI_ALL | LVNI_SELECTED)) != -1) {
						ListView_DeleteItem(hList,selitem);
						vector<RENAME_DATA>::iterator rit = m_editRenameList.begin();
						m_editRenameList.erase(rit+selitem);
					}
				}
				break;
			case IDC_TVROCK_COPY:
				{
					HWND hList = GetDlgItem(hWnd,IDC_TVROCK_LIST);
					int selitem = -1;
					while((selitem = ListView_GetNextItem(hList,selitem,LVNI_ALL | LVNI_SELECTED)) != -1) {
						m_editRenameData = m_editRenameList[selitem];
						InserRenameData(hWnd,&m_editRenameList,&m_editRenameData);
						selitem++;
					}
				}
				break;
			case IDOK:
				{
					UpdateRenameDataList();
					char szData[256];
					HWND hList = GetDlgItem(hWnd,IDC_TVROCK_LIST);
					wsprintf(szData,"%d",ListView_GetColumnWidth(hList,0));
					WritePrivateProfileString("TvRockReNameDlg","TYPEW",szData,m_szIniPath);
					wsprintf(szData,"%d",ListView_GetColumnWidth(hList,1));
					WritePrivateProfileString("TvRockReNameDlg","FINDW",szData,m_szIniPath);
					wsprintf(szData,"%d",ListView_GetColumnWidth(hList,2));
					WritePrivateProfileString("TvRockReNameDlg","RENAMEW",szData,m_szIniPath);
					wsprintf(szData,"%d",ListView_GetColumnWidth(hList,3));
					WritePrivateProfileString("TvRockReNameDlg","SYOBOW",szData,m_szIniPath);
					wsprintf(szData,"%d",ListView_GetColumnWidth(hList,4));
					WritePrivateProfileString("TvRockReNameDlg","NUMBERW",szData,m_szIniPath);
					::EndDialog(hWnd,IDOK);
				}
				break;
			case IDCANCEL:
				::EndDialog(hWnd,IDCANCEL);
				break;
			}
		}
		break;
	}
    return 0;
}

void SetEditNumData(HWND hWnd,vector<NUM_DATA>* pnumList,int pos)
{
	char szData[100];
	char szDateFormat[30];
	struct tm* ntm;
	SYSTEMTIME st;
	int size = pnumList->size();
	if(size - 1 < pos) 
		pos = size - 1;
	if(pos < 0)
		pos = 0;
	if(size < 2) {
		EnableWindow(GetDlgItem(hWnd,IDC_NUM_CTRL_SPIN),FALSE);
		SendMessage(GetDlgItem(hWnd,IDC_NUM_CTRL_SPIN),UDM_SETRANGE,0L,((size - 1) < 0 ? 0:size-1));
		SendMessage(GetDlgItem(hWnd,IDC_NUM_CTRL_SPIN),UDM_SETPOS,0L,pos);
	}
	else {
		EnableWindow(GetDlgItem(hWnd,IDC_NUM_CTRL_SPIN),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_NUM_DEL),TRUE);
		SendMessage(GetDlgItem(hWnd,IDC_NUM_CTRL_SPIN),UDM_SETRANGE,0L,size - 1);
		SendMessage(GetDlgItem(hWnd,IDC_NUM_CTRL_SPIN),UDM_SETPOS,0L,pos);
	}
	if(size == 0) {
		EnableWindow(GetDlgItem(hWnd,IDC_NUM_DEL),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_START_DATE),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_NO_TEXT),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_NUM_SPIN),FALSE);
		for(int w = 0;w < 7;w++) {
			EnableWindow(GetDlgItem(hWnd,IDC_WEEK_CHECK+w),FALSE);
		}
	}
	else {
		EnableWindow(GetDlgItem(hWnd,IDC_NUM_DEL),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_START_DATE),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_NO_TEXT),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_NUM_SPIN),TRUE);
		for(int w = 0;w < 7;w++) {
			EnableWindow(GetDlgItem(hWnd,IDC_WEEK_CHECK+w),TRUE);
		}
		if(size > 1) {
			char numtext[50];
			sprintf(numtext,"ioO%d",pos+1);
			SetWindowText(GetDlgItem(hWnd,IDC_STA_NUM),numtext);
		}
		else
			SetWindowText(GetDlgItem(hWnd,IDC_STA_NUM),"ioO");
		if((*pnumList)[pos].stime == 0)
			(*pnumList)[pos].stime = time(NULL);
		ntm = localtime(&((*pnumList)[pos].stime));
		st.wYear = ntm->tm_year + 1900;
		st.wMonth = ntm->tm_mon + 1;
		st.wDay = ntm->tm_mday;
		st.wDayOfWeek = ntm->tm_wday;
		st.wHour = ntm->tm_hour;
		st.wMinute = ntm->tm_min;
		st.wSecond = ntm->tm_sec;
		st.wMilliseconds = 0;
		strcpy(szDateFormat,"yyyy'/'MM'/'dd'('ddd')'");
		SendMessage(GetDlgItem(hWnd,IDC_START_DATE), DTM_SETFORMAT, 0, (LPARAM)szDateFormat);
		DateTime_SetSystemtime(GetDlgItem(hWnd,IDC_START_DATE), GDT_VALID, &st);
		sprintf(szData,"%d",(*pnumList)[pos].sno);
		SetDlgItemText(hWnd,IDC_NO_TEXT,szData);
		for(int w = 0;w < 7;w++) {
			if((*pnumList)[pos].bWeekCheck[w])
				SendMessage(GetDlgItem(hWnd, IDC_WEEK_CHECK+w), BM_SETCHECK, BST_CHECKED, 0L);
			else
				SendMessage(GetDlgItem(hWnd, IDC_WEEK_CHECK+w), BM_SETCHECK, BST_UNCHECKED, 0L);
		}
	}
}

void GetEditNumData(HWND hWnd,vector<NUM_DATA>* pnumList,int pos)
{
	int size = pnumList->size();
	if(size == 0)
		return;

	SYSTEMTIME sdt;
	struct tm stm;
	char szData[1024];
	DateTime_GetSystemtime(GetDlgItem(hWnd,IDC_START_DATE), &sdt);
	stm.tm_year = sdt.wYear - 1900;
	stm.tm_mon = sdt.wMonth - 1;
	stm.tm_mday = sdt.wDay;
	stm.tm_hour = 0;
	stm.tm_min = 0;
	stm.tm_sec = 0;
	(*pnumList)[pos].stime = mktime(&stm);
	GetDlgItemText(hWnd,IDC_NO_TEXT,szData,1024);
	(*pnumList)[pos].sno = atoi(szData);
	for(int w = 0;w < 7;w++) {
		(*pnumList)[pos].bWeekCheck[w] = (BST_CHECKED == SendMessage(GetDlgItem(hWnd, IDC_WEEK_CHECK+w) , BM_GETCHECK , 0 , 0));
	}
}

void SetEditRenameData(HWND hWnd)
{
	SetDlgItemText(hWnd,IDC_FIND_TEXT,m_editRenameData.stFind.c_str());
	SetDlgItemText(hWnd,IDC_FIND_TEXT2,m_editRenameData.stFindCh.c_str());
	SetDlgItemText(hWnd,IDC_RENAME_TEXT,m_editRenameData.stRename.c_str());
	SetDlgItemText(hWnd,IDC_SYOBO_TEXT,m_editRenameData.stSyoboFind.c_str());
	SendMessage(GetDlgItem(hWnd, IDC_SYOBO_TT), BM_SETCHECK, m_editRenameData.bSyoboTT ? BST_CHECKED:BST_UNCHECKED, 0L);
	SendMessage(GetDlgItem(hWnd, IDC_SYOBO_NB), BM_SETCHECK, m_editRenameData.bSyoboNB ? BST_CHECKED:BST_UNCHECKED, 0L);
	SendMessage(GetDlgItem(hWnd, IDC_SYOBO_SB), BM_SETCHECK, m_editRenameData.bSyoboSB ? BST_CHECKED:BST_UNCHECKED, 0L);
	SendMessage(GetDlgItem(hWnd, IDC_SYOBO_CH), BM_SETCHECK, m_editRenameData.bSyoboCH ? BST_CHECKED:BST_UNCHECKED, 0L);
	if(m_editRenameData.numList.size() - 1 < m_numPos)
		m_numPos = m_editRenameData.numList.size() - 1;
	if(m_numPos < 0)
		m_numPos = 0;
	SetEditNumData(hWnd,&m_editRenameData.numList,m_numPos);
}

void GetEditRenameData(HWND hWnd)
{
	SYSTEMTIME sdt;
	struct tm stm;
	char szData[1024];

	GetDlgItemText(hWnd,IDC_FIND_TEXT,szData,1024);
	m_editRenameData.stFind = szData;
	GetDlgItemText(hWnd,IDC_FIND_TEXT2,szData,1024);
	m_editRenameData.stFindCh = szData;
	if(m_editRenameData.stFindCh.empty())
		m_editRenameData.type = 1;
	else if(m_editRenameData.stFind.empty())
		m_editRenameData.type = 2;
	else
		m_editRenameData.type = 0;
	GetDlgItemText(hWnd,IDC_RENAME_TEXT,szData,1024);
	m_editRenameData.stRename = szData;
	GetDlgItemText(hWnd,IDC_SYOBO_TEXT,szData,1024);
	m_editRenameData.stSyoboFind = szData;
	m_editRenameData.bSyoboTT = (BST_CHECKED == SendMessage(GetDlgItem(hWnd, IDC_SYOBO_TT) , BM_GETCHECK , 0 , 0));
	m_editRenameData.bSyoboNB = (BST_CHECKED == SendMessage(GetDlgItem(hWnd, IDC_SYOBO_NB) , BM_GETCHECK , 0 , 0));
	m_editRenameData.bSyoboSB = (BST_CHECKED == SendMessage(GetDlgItem(hWnd, IDC_SYOBO_SB) , BM_GETCHECK , 0 , 0));
	m_editRenameData.bSyoboCH = (BST_CHECKED == SendMessage(GetDlgItem(hWnd, IDC_SYOBO_CH) , BM_GETCHECK , 0 , 0));
}

LRESULT CALLBACK TvRockSetupDlgProc(HWND hWnd,UINT meg,WPARAM wp,LPARAM lp)
{
    switch ( meg )
    {
	case WM_INITDIALOG:
		{
			HMENU hSysMenu = GetSystemMenu(hWnd,FALSE);
			InsertMenu(hSysMenu,SC_CLOSE,MF_BYCOMMAND|MF_STRING,IDM_TVROCK_COPY,"Rs[(&C)");
			InsertMenu(hSysMenu,SC_CLOSE,MF_BYCOMMAND|MF_STRING,IDM_TVROCK_PASTE,"\t(&P)");
			SendMessage(GetDlgItem(hWnd,IDC_NUM_SPIN),UDM_SETRANGE,0L,1000);
			m_numPos = 0;
			SetEditRenameData(hWnd);
		}
		break;
	case WM_SYSCOMMAND:
		{
			switch (LOWORD(wp)) {
			case IDM_TVROCK_COPY:
				{
					string stText;
					char szText[2048];
					GetEditRenameData(hWnd);

					sprintf(szText,"FindText=%s\r\n",m_editRenameData.stFind.c_str());
					stText += szText;
					sprintf(szText,"FindTextCh=%s\r\n",m_editRenameData.stFindCh.c_str());
					stText += szText;
					sprintf(szText,"FindType=%d\r\n",m_editRenameData.type);
					stText += szText;
					sprintf(szText,"RenameText=%s\r\n",m_editRenameData.stRename.c_str());
					stText += szText;
					sprintf(szText,"SyoboFind=%s\r\n",m_editRenameData.stSyoboFind.c_str());
					stText += szText;
					sprintf(szText,"SyoboTT=%d\r\n",m_editRenameData.bSyoboTT);
					stText += szText;
					sprintf(szText,"SyoboNB=%d\r\n",m_editRenameData.bSyoboNB);
					stText += szText;
					sprintf(szText,"SyoboSB=%d\r\n",m_editRenameData.bSyoboSB);
					stText += szText;
					sprintf(szText,"SyoboCH=%d\r\n",m_editRenameData.bSyoboCH);
					stText += szText;
					for(int ni = 0;ni < m_editRenameData.numList.size();ni++) {
						if(ni == 0)
							sprintf(szText,"StartTime=%I64d\r\n",m_editRenameData.numList[ni].stime);
						else
							sprintf(szText,"StartTime%06d=%I64d\r\n",ni,m_editRenameData.numList[ni].stime);
						stText += szText;
						if(ni == 0)
							sprintf(szText,"StartNo=%d\r\n",m_editRenameData.numList[ni].sno);
						else
							sprintf(szText,"StartNo%06d=%d\r\n",ni,m_editRenameData.numList[ni].sno);
						stText += szText;
						for(int w = 0;w < 7;w++) {
							if(ni == 0)
								sprintf(szText,"WeekCheck%d=%d\r\n",w,m_editRenameData.numList[ni].bWeekCheck[w]);
							else
								sprintf(szText,"WeekCheck%06d_%d=%d\r\n",ni,w,m_editRenameData.numList[ni].bWeekCheck[w]);
							stText += szText;
						}
					}
					// Nbv{[h̃I[v
					if( !::OpenClipboard(NULL) )
						break;

					// q[vɃ̈mۂARs[
					int iStrLen = stText.length() + 1;
					HGLOBAL hMem = ::GlobalAlloc(GMEM_FIXED, iStrLen);
					LPTSTR pMem = (LPTSTR)hMem;
					::lstrcpy(pMem, (char*)stText.c_str());

					// Nbv{[h֕Rs[AN[Y
					::EmptyClipboard();	// Nbv{[h̒gɂ
					::SetClipboardData(CF_TEXT, hMem);
					::CloseClipboard();
				}
				break;
			case IDM_TVROCK_PASTE:
				{
					string stText;

					// Nbv{[hɃeLXgf[^Ă邩𒲂ׂ
					if( !::IsClipboardFormatAvailable(CF_TEXT) )
						break;

					// Nbv{[h̃I[v
					if( !::OpenClipboard(NULL) )
						break;

					// Nbv{[hf[^擾AstrTextփRs[
					HANDLE hMem = ::GetClipboardData(CF_TEXT);
					LPTSTR pMem = (LPTSTR)::GlobalLock(hMem);
					stText = (char*)pMem;
					::GlobalUnlock(hMem);
					::CloseClipboard();

					string stInput;
					m_editRenameData.numList.clear();
					NUM_DATA num;
					while(!stText.empty()) {
						string::size_type find = stText.find("\r\n");
						if(find == string::npos) {
							stInput = stText;
							stText.erase();
						}
						else {
							stInput = stText.substr(0,find);
							stText.erase(0,find+2);
						}
						if(stInput.compare(0,9,"FindText=") == 0) {
							m_editRenameData.stFind = stInput.substr(9);
						}
						else if(stInput.compare(0,11,"FindTextCh=") == 0) {
							m_editRenameData.stFindCh = stInput.substr(11);
						}
						else if(stInput.compare(0,9,"FindType=") == 0) {
							m_editRenameData.type = atoi(stInput.substr(9).c_str());
						}
						else if(stInput.compare(0,11,"RenameText=") == 0) {
							m_editRenameData.stRename = stInput.substr(11);
						}
						else if(stInput.compare(0,10,"SyoboFind=") == 0) {
							m_editRenameData.stSyoboFind = stInput.substr(10);
						}
						else if(stInput.compare(0,8,"SyoboTT=") == 0) {
							m_editRenameData.bSyoboTT = atoi(stInput.substr(8).c_str());
						}
						else if(stInput.compare(0,8,"SyoboNB=") == 0) {
							m_editRenameData.bSyoboNB = atoi(stInput.substr(8).c_str());
						}
						else if(stInput.compare(0,8,"SyoboSB=") == 0) {
							m_editRenameData.bSyoboSB = atoi(stInput.substr(8).c_str());
						}
						else if(stInput.compare(0,8,"SyoboCH=") == 0) {
							m_editRenameData.bSyoboCH = atoi(stInput.substr(8).c_str());
						}
						else if(stInput.compare(0,9,"StartTime") == 0) {
							if(stInput[9] == '=') {
								if(m_editRenameData.numList.size() == 0)
									m_editRenameData.numList.push_back(num);
								m_editRenameData.numList[0].stime = _atoi64(stInput.substr(10).c_str());
							}
							else {
								int ni = atoi(stInput.substr(9,6).c_str());
								while(m_editRenameData.numList.size() <= ni)
									m_editRenameData.numList.push_back(num);
								m_editRenameData.numList[ni].stime = _atoi64(stInput.substr(16).c_str());
							}
						}
						else if(stInput.compare(0,7,"StartNo") == 0) {
							if(stInput[7] == '=') {
								if(m_editRenameData.numList.size() == 0)
									m_editRenameData.numList.push_back(num);
								m_editRenameData.numList[0].sno = atoi(stInput.substr(8).c_str());
							}
							else {
								int ni = atoi(stInput.substr(7,6).c_str());
								while(m_editRenameData.numList.size() <= ni)
									m_editRenameData.numList.push_back(num);
								m_editRenameData.numList[ni].sno = atoi(stInput.substr(14).c_str());
							}
						}
						else if(stInput.compare(0,9,"WeekCheck") == 0) {
							if(stInput[10] == '=') {
								if(m_editRenameData.numList.size() == 0)
									m_editRenameData.numList.push_back(num);
								int w = atoi(stInput.substr(9).c_str());
								m_editRenameData.numList[0].bWeekCheck[w] = atoi(stInput.substr(11).c_str());
							}
							else {
								int ni = atoi(stInput.substr(9,6).c_str());
								int w = atoi(stInput.substr(16).c_str());
								while(m_editRenameData.numList.size() <= ni)
									m_editRenameData.numList.push_back(num);
								m_editRenameData.numList[ni].bWeekCheck[w] = atoi(stInput.substr(18).c_str());
							}
						}
					}
					SetEditRenameData(hWnd);
				}
				break;
			}
		}
		break;
	case WM_VSCROLL:
		{
			if((HWND)lp == GetDlgItem(hWnd,IDC_NUM_CTRL_SPIN)) {
				int ctl = LOWORD(wp);
				int pos  = HIWORD(wp);
				if(ctl == 4) {
					GetEditNumData(hWnd,&m_editRenameData.numList,m_numPos);
					m_numPos = pos;
					SetEditNumData(hWnd,&m_editRenameData.numList,m_numPos);
				}
			}
		}
		break;
	case WM_COMMAND:
		if(HIWORD(wp) == 0x00) {
			switch ( LOWORD(wp) )
			{
			case IDC_NUM_ADD:
				{
					GetEditNumData(hWnd,&m_editRenameData.numList,m_numPos);
					NUM_DATA num;
					int size = m_editRenameData.numList.size();
					if(size == 0) {
						m_numPos = 0;
						m_editRenameData.numList.push_back(num);
					}
					else {
						num = m_editRenameData.numList[m_numPos];
						if(size - 1 == m_numPos)
							m_editRenameData.numList.push_back(num);
						else {
							vector<NUM_DATA>::iterator nit = m_editRenameData.numList.begin();
							m_editRenameData.numList.insert(nit+m_numPos+1,num);
						}
						m_numPos++;
					}
					SetEditNumData(hWnd,&m_editRenameData.numList,m_numPos);
				}
				break;
			case IDC_NUM_DEL:
				{
					vector<NUM_DATA>::iterator nit = m_editRenameData.numList.begin();
					m_editRenameData.numList.erase(nit+m_numPos);
					if(m_editRenameData.numList.size() <= m_numPos)
						m_numPos = m_editRenameData.numList.size() - 1;
					SetEditNumData(hWnd,&m_editRenameData.numList,m_numPos);
				}
				break;
			case IDOK:
				{
					GetEditRenameData(hWnd);
					GetEditNumData(hWnd,&m_editRenameData.numList,m_numPos);
					vector<NUM_DATA> numList = m_editRenameData.numList;
					m_editRenameData.numList.clear();
					for(int ni = 0;ni < numList.size();ni++) {
						int pos = -1;
						for(int ni2 = 0;ni2 < m_editRenameData.numList.size();ni2++) {
							if(m_editRenameData.numList[ni2].stime == numList[ni].stime) {
								if(m_editRenameData.numList[ni2].sno >= numList[ni].sno) {
									pos = ni2;
									break;
								}
							}
							else if(m_editRenameData.numList[ni2].stime > numList[ni].stime) {
								pos = ni2;
								break;
							}
						}
						if(pos == -1)
							m_editRenameData.numList.push_back(numList[ni]);
						else {
							vector<NUM_DATA>::iterator nit = m_editRenameData.numList.begin();
							m_editRenameData.numList.insert(nit+pos,numList[ni]);
						}
					}
					::EndDialog(hWnd,IDOK);
				}
				break;
			case IDCANCEL:
				::EndDialog(hWnd,IDCANCEL);
				break;
			}
		}
		break;
	}
    return 0;
}

BOOL tsreadCallBack(long readbyte,long totalbyte,HWND data)
{
	static time_t lasttime = -1;
	HWND hWnd = data;
	HWND hCount = GetDlgItem(hWnd,IDC_READ_COUNT);
	HWND hProg = GetDlgItem(hWnd,IDC_READ_PROG);
	time_t nowtime = time(NULL);
	char szCount[1024];
	if(nowtime != lasttime) {
		char szRead[20],szTotal[20],szBuf[20],szScr[1024],szOut[2048];
		int len,spos;
		sprintf(szBuf,"%ld",(long)(readbyte/1000));			// 100000
		if(strlen(szBuf) >= 4) {
			for(len = strlen(szBuf)-3;len > 0;len-=3)
				spos = len;
			szRead[0] = 0x00;
			for(len = 0;len < strlen(szBuf);) {
				strncat(szRead,&szBuf[len],spos);
				len += spos;
				spos = 3;
				if(len < strlen(szBuf))
					strcat(szRead,",");
			}
		}
		else
			strcpy(szRead,szBuf);
		sprintf(szBuf,"%ld",(long)(totalbyte/1000));
		if(strlen(szBuf) >= 4) {
			for(len = strlen(szBuf)-3;len > 0;len-=3)
				spos = len;
			szTotal[0] = 0x00;
			for(len = 0;len < strlen(szBuf);) {
				strncat(szTotal,&szBuf[len],spos);
				len += spos;
				spos = 3;
				if(len < strlen(szBuf))
					strcat(szTotal,",");
			}
		}
		else
			strcpy(szTotal,szBuf);
		wsprintf(szCount,"%sMB/%sMB",szRead,szTotal);
		SetWindowText(hCount,szCount);
		lasttime = nowtime;
		if(totalbyte > 0) {
			SendMessage(hProg, PBM_SETPOS,
				(WPARAM)(readbyte*100)/totalbyte,(LPARAM)0);
		}
	}
	if(readbyte == totalbyte) {
		SendMessage(hProg, PBM_SETPOS,
			(WPARAM)100,(LPARAM)0);
		if(m_bTsreadCancel)
			::EndDialog(hWnd,IDCANCEL);
		else
			::EndDialog(hWnd,IDOK);
	}
	MSG msg;
	for(int i = 0;i < 1000;i++) {
		if(PeekMessage(&msg, hWnd, 0, 0, PM_REMOVE)){
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else
			break;
	}
	if(m_bTsreadCancel)
		return FALSE;
	return TRUE;
}

LRESULT CALLBACK FileReadDlgProc(HWND hWnd,UINT msg,WPARAM wp,LPARAM lp)
{
    switch ( msg )
    {
	case WM_INITDIALOG:
		{
			HWND hDesk;
			RECT DeskRect, CRect;
			INT S_PosX, S_PosY;

			hDesk = GetDesktopWindow();
			GetWindowRect(hDesk, &DeskRect);
			GetWindowRect(hWnd, &CRect);
			S_PosX = (INT)(DeskRect.right - (CRect.right - CRect.left)) / 2;
			S_PosY = (INT)(DeskRect.bottom - (CRect.bottom - CRect.top)) / 2;

			SetWindowPos(hWnd, NULL, S_PosX, S_PosY, 0, 0, SWP_NOSIZE | SWP_NOZORDER);

			char szFileName[256],drv[10],path[256],name[256],ext[256];
			_splitpath(m_FileReadDlg_FileName,drv,path,name,ext);
			_makepath(szFileName,NULL,NULL,name,ext);
			SetDlgItemText(hWnd,IDC_FILE_NAME,szFileName);
			SetDlgItemText(hWnd,IDC_READ_COUNT,"");
			HWND hProg = GetDlgItem(hWnd,IDC_READ_PROG);
			SendMessage(hProg, PBM_SETRANGE,
				(WPARAM)0,
				MAKELPARAM(0, 100));
			SendMessage(hProg, PBM_SETPOS,
				(WPARAM)0,(LPARAM)0);
			SetTimer(hWnd,2000,500,NULL);
		}
		break;
	case WM_TIMER:
		if(wp == 2000) {
			KillTimer(hWnd,2000);
			m_bTsreadCancel = FALSE;
			m_pTs->ReadPos = m_nReadStartPos;
			m_pTs->ReadSize = m_nReadSize;
			m_pTs->tsread(m_FileReadDlg_FileName,tsreadCallBack,hWnd);
		}
    case WM_COMMAND:
        switch ( LOWORD(wp) )
        {
		case IDCANCEL:
			if(MessageBox(hWnd,"t@C̓ǂݍ݂𒆒f܂H","f",MB_YESNO| MB_ICONQUESTION) == IDYES)
				m_bTsreadCancel = TRUE;
            break;
        }
        break;
    }
    return 0;
}

void SetFileList(HWND hWnd);
void SetItemText(HWND hWnd,int itemNo,BOOL bIns = TRUE);

void SetItemText(HWND hWnd,int itemNo,BOOL bIns)
{
	HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
	vector<int> typeList;
	vector<string> spList;
	LV_ITEM item;
	int selitem = itemNo;
	if(!bIns) {
		item.mask = LVIF_PARAM;
		item.iItem = itemNo;
		item.iSubItem = 0;
		ListView_GetItem(hList,&item);
		selitem = item.lParam;
	}
	vector<FILE_DATA>::iterator fit = m_FileList.begin() + selitem;

	for(int id = IDC_TSR_CMB;id <= IDC_TSR_CMB4;id++) {
		HWND hCmbList = GetDlgItem(hWnd,id);
		int type = ComboBox_GetCurSel(hCmbList);
		typeList.push_back(type);
	}
	for(int id = IDC_TSR_SP1;id <= IDC_TSR_SP5;id++) {
		char sp[256];
		GetDlgItemText(hWnd,id,sp,256);
		string stSp = sp;
		spList.push_back(stSp);
	}

	m_bNotFileRename = (BST_CHECKED == SendMessage(GetDlgItem(hWnd, IDC_TSR_NOTRENAME) , BM_GETCHECK , 0 , 0));

	char szDateTime[100];
	char szNewName[512],sztmp[256];
	item.mask = LVIF_TEXT|LVIF_PARAM;
	item.pszText = (char*)fit->stFileName.c_str();
	item.iItem = itemNo;
	item.iSubItem = 0;
	item.lParam = selitem;
	int insitem;
	if(bIns)
		insitem = ListView_InsertItem(hList,&item);
	else {
		insitem  = itemNo;
		ListView_SetItem(hList,&item);
	}
	int nOverLen = 0;
	fit->bFileNameError = FALSE;
	
	char drv[10],path[256],name[256],ext[256],fullPathName[1024];
	_splitpath((char*)fit->stFilePath.c_str(),drv,path,name,ext);
	szNewName[0] = 0x00;
	vector<int>::iterator tit = typeList.begin();
	vector<string>::iterator sit = spList.begin();
	if(m_bNotFileRename) {
		_makepath(szNewName,NULL,NULL,name,ext);
	}
	else {
		if(fit->progList[fit->nSelNo].stime != 0) {
			bool bre = false;
			for(int ri = 0;!bre && ri < m_RenameList.size();ri++) {
				string outstring;
				bre = tsreplace(fit->stFileName,&(fit->progList[fit->nSelNo]), &m_RenameList[ri],outstring,hWnd);
				if(bre) {
					strncpy(szNewName,outstring.c_str(),500);
				}
			}
			if(!bre) {
				while(tit != typeList.end() && sit != spList.end()) {
					//if(szNewName[0] != 0x00)
					//	strcat(szNewName," ");
					strcat(szNewName,(char*)(*sit).c_str());
					switch(*tit) {
						case 1:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stName.c_str());
							break;
						case 2:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stChName.c_str());
							break;
						case 3:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stDate.c_str());
							break;
						case 4:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stSTime.c_str());
							break;
						case 5:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stDate28.c_str());
							break;
						case 6:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stSTime28.c_str());
							break;
						case 7:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stYDate.c_str());
							break;
						case 8:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stYDate28.c_str());
							break;
						case 9:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stY2Date.c_str());
							break;
						case 10:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stY2Date28.c_str());
							break;
						case 11:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stS2Time.c_str());
							break;
						case 12:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stS2Time28.c_str());
							break;
						case 13:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stYDateSTime.c_str());
							break;
						case 14:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stYDateSTime28.c_str());
							break;
						case 15:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stY2_Date.c_str());
							break;
						case 16:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stY2_Date28.c_str());
							break;
						case 17:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stY3_Date.c_str());
							break;
						case 18:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stY3_Date28.c_str());
							break;
						case 19:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stAv.c_str());
							break;
						case 20:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stGenre.c_str());
							break;
						case 21:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stGenre2.c_str());
							break;
						case 22:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stGenre0.c_str());
							break;
						case 23:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stY4_Date.c_str());
							break;
						case 24:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stY4_Date28.c_str());
							break;
						case 25:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stContAll.c_str());
							break;
						case 26:
							strcat(szNewName,(char*)fit->progList[fit->nSelNo].stContLine.c_str());
							break;
					}
					tit++;
					sit++;
				}
				if(sit != spList.end())
					strcat(szNewName,(char*)(*sit).c_str());
			}
			if(szNewName[0] != 0x00) {
				if(ext[0] == 0x00)
					strcat(szNewName,".ts");
				else
					strcat(szNewName,ext);
			}
		}

		string sttmp = szNewName;
		replace(sttmp,":","F");
		replace(sttmp,"<","");
		replace(sttmp,">","");
		replace(sttmp,"\\","");
		replace(sttmp,"/","^");
		replace(sttmp,"*","");
		replace(sttmp,"?","H");
		replace(sttmp,"|","b");
		replace(sttmp,"\r","");
		replace(sttmp,"\n","");
		strcpy(szNewName,(char*)sttmp.c_str());
	}
	_splitpath(szNewName,NULL,NULL,name,ext);
	if(strlen(drv)+strlen(path)+strlen(name)+strlen(ext) > 256)
		fit->bFileNameError = TRUE;

	//char *szNotChar = ":<>\\/*?|";

	//for(int i = 0;i < strlen(szNotChar);i++) {
	//	for(int is = 0;is < strlen(name);is++) {
	//		if(_ismbblead(name[is])) {
	//			is++;
	//			continue;
	//		}
	//		if(name[is] == szNotChar[i])
	//			name[is] = '_';
	//	}
	//}

	_makepath(fullPathName,drv,path,name,ext);
	fit->stNewFilePath = fullPathName;

	_makepath(szNewName,NULL,NULL,name,ext);
	fit->stNewName = szNewName;
	item.mask = LVIF_TEXT;
	item.pszText = (char*)fit->stNewName.c_str();
	item.iItem = insitem;
	item.iSubItem = 1;
	ListView_SetItem(hList, &item);
	item.mask = LVIF_TEXT;
	item.pszText = (char*)fit->progList[fit->nSelNo].stName.c_str();
	item.iItem = insitem;
	item.iSubItem = 2;
	ListView_SetItem(hList, &item);
	item.mask = LVIF_TEXT;
	item.pszText = (char*)fit->progList[fit->nSelNo].stChName.c_str();
	item.iItem = insitem;
	item.iSubItem = 3;
	ListView_SetItem(hList, &item);
	wsprintf(szDateTime,"%s %s",(char*)fit->progList[fit->nSelNo].stDate.c_str(),(char*)fit->progList[fit->nSelNo].stSTime.c_str());
	item.mask = LVIF_TEXT;
	item.pszText = szDateTime;
	item.iItem = insitem;
	item.iSubItem = 4;
	ListView_SetItem(hList, &item);
	item.mask = LVIF_TEXT;
	item.pszText = (char*)fit->progList[fit->nSelNo].stCont.c_str();
	item.iItem = insitem;
	item.iSubItem = 5;
	ListView_SetItem(hList, &item);
	item.mask = LVIF_TEXT;
	item.pszText = (char*)fit->progList[fit->nSelNo].stAv.c_str();
	item.iItem = insitem;
	item.iSubItem = 6;
	ListView_SetItem(hList, &item);
	item.mask = LVIF_TEXT;
	item.pszText = (char*)fit->progList[fit->nSelNo].stGenre0.c_str();
	item.iItem = insitem;
	item.iSubItem = 7;
	ListView_SetItem(hList, &item);
	if(fit->bChange)
		ListView_SetItemState(hList,insitem,LVIS_SELECTED,LVIS_SELECTED);
}

void SetFileList(HWND hWnd)
{
	HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
	ListView_DeleteAllItems(hList);

	int itemNo = 0;
	vector<FILE_DATA>::iterator fit = m_FileList.begin();
	while(fit != m_FileList.end()) {
		SetItemText(hWnd,itemNo,TRUE);
		fit->bChange = FALSE;
		itemNo++;
		fit++;
	}
	ListView_EnsureVisible(hList,itemNo-1,FALSE);
}

BOOL ReadEpgData(HWND hWnd,int i,char* szPathName)
{
	char drv[10],path[256],name[256],ext[256],szName[256];
	vector<FILE_DATA>::iterator fit = m_FileList.begin();
	BOOL bExist = FALSE;
	while(fit != m_FileList.end()) {
		if(fit->stFilePath.compare(szPathName) == 0) {
			bExist = TRUE;
			break;
		}
		fit++;
	}
	if(bExist)
		return TRUE;
	m_pTs = new CTsData();
	if(m_bAuto && m_bIconStart)
		m_pTs->tsread(szPathName);
	else {
		m_FileReadDlg_FileName = szPathName;
		if(IDCANCEL == DialogBox(hInst,MAKEINTRESOURCE(IDD_FILE_READ),
			hWnd,(DLGPROC)FileReadDlgProc)) {
				return FALSE;
		}
	}
	//m_pTs->tsread(szPathName);
	int networkId = 0;
	map<DWORD,CH_NAME> mapSvcName;
	mapSvcName.clear();
	int lastsvcid = -1;
	for(int svc = 0;svc < SVC_MAX;svc++) {
		if(!m_pTs->SvcData[svc])
			break;
		// }``l͕\Ȃ
		BOOL bMulti = FALSE;
		if(lastsvcid+1 == m_pTs->SvcData[svc]->Service_id) {
			lastsvcid = m_pTs->SvcData[svc]->Service_id;
			bMulti = TRUE; 
			//continue;
		}
		networkId = GetNetId(m_pTs->SvcData[svc]->chNo);
		if(GetNetId(m_pTs->SvcData[svc]->chNo) > 4)
			bMulti = FALSE;
		lastsvcid = m_pTs->SvcData[svc]->Service_id;
		if(m_pTs->SvcData[svc]->nTsNameLen > 0 && !bMulti) {
			char *poutstr = new char[m_pTs->SvcData[svc]->nTsNameLen*2+20];
			Convert_jpn_arib_char((char*)m_pTs->SvcData[svc]->szTsName,m_pTs->SvcData[svc]->nTsNameLen,poutstr,m_pTs->SvcData[svc]->nTsNameLen*2+20);
			if(strlen(poutstr) >= 100)
				poutstr[99] = 0x00;
			strcpy(szName,poutstr);
			delete[] poutstr;
		}
		else {
			if(m_pTs->SvcData[svc]->nNameLen > 0) {
				char *poutstr = new char[m_pTs->SvcData[svc]->nNameLen*2+20];
				Convert_jpn_arib_char((char*)m_pTs->SvcData[svc]->szName,m_pTs->SvcData[svc]->nNameLen,poutstr,m_pTs->SvcData[svc]->nNameLen*2+20);
				if(strlen(poutstr) >= 100)
					poutstr[99] = 0x00;
				strcpy(szName,poutstr);
				delete[] poutstr;
			}
			else {
				if(((m_pTs->SvcData[svc]->chNo)&0xfff) > 0)
					wsprintf(szName,"%dch",((m_pTs->SvcData[svc]->chNo)&0xfff));
				else {
					if(GetNetId(m_pTs->SvcData[svc]->chNo) == 4)
						wsprintf(szName,"BS%d",m_pTs->SvcData[svc]->Service_id);
					else if(GetNetId(m_pTs->SvcData[svc]->chNo) == 6 || GetNetId(m_pTs->SvcData[svc]->chNo) == 7)
						wsprintf(szName,"CS%d",m_pTs->SvcData[svc]->Service_id);
					else
						wsprintf(szName,"%d",m_pTs->SvcData[svc]->Service_id);
				}
			}
		}
		string stName = szName;
		mapSvcName[m_pTs->SvcData[svc]->Service_id].szChName = stName;
		if(m_pTs->SvcData[svc]->nNameLen > 0) {
			char *poutstr = new char[m_pTs->SvcData[svc]->nNameLen*2+20];
			Convert_jpn_arib_char((char*)m_pTs->SvcData[svc]->szName,m_pTs->SvcData[svc]->nNameLen,poutstr,m_pTs->SvcData[svc]->nNameLen*2+20);
			if(strlen(poutstr) >= 100)
				poutstr[99] = 0x00;
			strcpy(szName,poutstr);
			delete[] poutstr;
			stName = szName;
		}
		mapSvcName[m_pTs->SvcData[svc]->Service_id].szSubName = stName;
	}
	FILE_DATA filedata;
	filedata.bChange = FALSE;
	filedata.stFilePath = szPathName;
	_splitpath(szPathName,drv,path,name,ext);
	_makepath(szName,NULL,NULL,name,ext);
	filedata.stFileName = szName;
	vector<PAT_TABLE>::iterator tit = m_pTs->PatList.begin();
	while(tit != m_pTs->PatList.end()) {
		MsgOut("Pat Version = %d\r\n",tit->patVersion);
		vector<PAT_DATA>::iterator dit = tit->patTable.begin();
		while(dit != tit->patTable.end()) {
			MsgOut("PID:%03x(%d),VideoPID:%03x(%d)\r\n",dit->pmtPid,dit->Service_id,dit->vPid,dit->vCount);
			char szname[160],szcont[340],szsubname[160];
			int vt = 0,at = 0,aq = 0,genre = -1,genre2 = -1;
			int eventId = 0;
			time_t stime;
			time_t etime;
			szname[0] = 0x00;
			szcont[0] = 0x00;
			szsubname[0] = 0x00;
			BYTE* pSecData = dit->nowEit.GetData();
			BYTE contdata[4096];
			int contlen = 0;
			char szdetails[8500];
			szdetails[0] = 0x00;
			if(pSecData) {
				BYTE* ebuf = &pSecData[14];
				eventId = (ebuf[0]<<8)+ebuf[1];
				int section_length = dit->nowEit.GetDataSize()-3;
				// Epgf[^̊JnAԂ擾
				int looplen = ((ebuf[10]<<8)+ebuf[11])&0x0fff;
				m_pTs->ConvDate(&ebuf[2],&stime,&etime);
				BYTE* lbuf = &ebuf[12];
				while(lbuf < &ebuf[12+looplen] && lbuf < &pSecData[section_length+3-4]) {
					BYTE* dbuf = lbuf;
					int dlen = lbuf[1];
					lbuf += (dlen+2);
					if(dbuf[0] == 0x4d) {
						int name = 0;
						dbuf += 5;
						while(dbuf < lbuf) {
							int len = dbuf[0];
							dbuf++;
							if(len > 0) {
								char *poutstr = new char[len*2+80];
								Convert_jpn_arib_char((char*)dbuf,len,poutstr,len*2+80);
								if(name == 0) {
									if(strlen(poutstr) >= 160)
										poutstr[99] = 0x00;
									strcpy(szname,poutstr);
								}
								else {
									if(strlen(poutstr) >= 340)
										poutstr[339] = 0x00;
									strcpy(szcont,poutstr);
								}
								delete[] poutstr;
								dbuf+=len;
								name++;
							}
						}
					}
					else if(dbuf[0] == 0x50) {
						vt = dbuf[3];
					}
					else if(dbuf[0] == 0xc4) {
						at = dbuf[3];
						aq = (dbuf[7]&0x30)/16;
					}
					else if(dbuf[0] == 0x54) {
						for(int gn = 0;gn < dlen;gn+=2) {
							genre = (dbuf[2+gn]>>4)&0x0f;
							genre2 = (dbuf[2+gn]&0x0f);
							if(genre != 0xe)
								break;
						}
					}
					else if(dbuf[0] == 0x4e) {
						int descriptor_number = (dbuf[2]>>4);
						int last_descriptor_number = (dbuf[2]&0x0f);
						int length_of_items = dbuf[6];
						int name = 0;
						dbuf += 7;
						while(dbuf < lbuf) {
							int len = dbuf[0];
							dbuf++;
							if(len > 0) {
								if(name == 0) {
									if(contlen) {
										char *poutstr = new char[contlen*2+80];
										Convert_jpn_arib_char((char*)contdata,contlen,poutstr,contlen*2+80);
										strcat(szdetails,poutstr);
										contlen = 0;
										delete[] poutstr;
									}
									char *poutstr = new char[len*2+80];
									Convert_jpn_arib_char((char*)dbuf,len,poutstr,len*2+80);
									if(strlen(poutstr) >= 99)
										poutstr[99] = 0x00;
									wsprintf(szsubname,"\r\ry%sz\r",poutstr);
									strcat(szdetails,szsubname);
									delete[] poutstr;
								}
								else {
									memcpy(&contdata[contlen],dbuf,len);
									contlen += len;
								}
								dbuf+=len;
							}
							name++;
						}
					}
				}
				if(contlen) {
					char *poutstr = new char[contlen*2+80];
					Convert_jpn_arib_char((char*)contdata,contlen,poutstr,contlen*2+80);
					strcat(szdetails,poutstr);
					contlen = 0;
					delete[] poutstr;
				}
			}
			pSecData = dit->nowSit.GetData();
			if(pSecData) {
				// Epgf[^̊JnAԂ擾
				int looplen = dit->nowSit.GetDataSize();
				m_pTs->ConvDate(dit->nowSit.date,&stime,&etime);
				BYTE* lbuf = pSecData;
				while(lbuf < &pSecData[looplen]) {
					BYTE* dbuf = lbuf;
					int dlen = lbuf[1];
					lbuf += (dlen+2);
					if(dbuf[0] == 0x4d) {
						int name = 0;
						dbuf += 5;
						while(dbuf < lbuf) {
							int len = dbuf[0];
							dbuf++;
							if(len > 0) {
								char *poutstr = new char[len*2+80];
								Convert_jpn_arib_char((char*)dbuf,len,poutstr,len*2+80);
								if(name == 0) {
									if(strlen(poutstr) >= 160)
										poutstr[99] = 0x00;
									strcpy(szname,poutstr);
								}
								else {
									if(strlen(poutstr) >= 340)
										poutstr[339] = 0x00;
									strcpy(szcont,poutstr);
								}
								delete[] poutstr;
								dbuf+=len;
								name++;
							}
						}
					}
					else if(dbuf[0] == 0x50) {
						vt = dbuf[3];
					}
					else if(dbuf[0] == 0xc4) {
						at = dbuf[3];
						aq = (dbuf[7]&0x30)/16;
					}
					else if(dbuf[0] == 0x54) {
						for(int gn = 0;gn < dlen;gn+=2) {
							genre = (dbuf[2+gn]>>4)&0x0f;
							genre2 = (dbuf[2+gn]&0x0f);
							if(genre != 0xe)
								break;
						}
					}
					else if(dbuf[0] == 0x4e) {
						int descriptor_number = (dbuf[2]>>4);
						int last_descriptor_number = (dbuf[2]&0x0f);
						int length_of_items = dbuf[6];
						int name = 0;
						dbuf += 7;
						while(dbuf < lbuf) {
							int len = dbuf[0];
							dbuf++;
							if(len > 0) {
								if(name == 0) {
									if(contlen) {
										char *poutstr = new char[contlen*2+80];
										Convert_jpn_arib_char((char*)contdata,contlen,poutstr,contlen*2+80);
										strcat(szdetails,poutstr);
										contlen = 0;
										delete[] poutstr;
									}
									char *poutstr = new char[len*2+80];
									Convert_jpn_arib_char((char*)dbuf,len,poutstr,len*2+80);
									if(strlen(poutstr) >= 99)
										poutstr[99] = 0x00;
									wsprintf(szsubname,"\r\r%s\r",poutstr);
									strcat(szdetails,szsubname);
									delete[] poutstr;
								}
								else {
									memcpy(&contdata[contlen],dbuf,len);
									contlen += len;
								}
								dbuf+=len;
							}
							name++;
						}
					}
				}
				if(contlen) {
					char *poutstr = new char[contlen*2+80];
					Convert_jpn_arib_char((char*)contdata,contlen,poutstr,contlen*2+80);
					strcat(szdetails,poutstr);
					contlen = 0;
					delete[] poutstr;
				}
			}
			// ԑg
			if(szname[0] != 0x00) {
				PROG_DATA progdata;
				progdata.stime = stime;
				progdata.etime = etime;
				progdata.eventId = eventId;
				progdata.stName = szname;
				progdata.stNameBack = szname;
				progdata.stCont = szcont;
				progdata.serviceId = dit->Service_id;
				progdata.stDetails = szdetails;
				progdata.vCount = dit->vCount;
				int nhour,nmin;
				struct tm* enTime;
				struct tm* stTime;
				char* szwday[7] = {"","","","","","","y"};
				char sztmp[1024];
				char szDate[50];
				map<DWORD,CH_NAME>::iterator sit = mapSvcName.find(dit->Service_id);
				if(sit != mapSvcName.end()) {
					if(vt>>4 == 0 || vt>>4 == 0x0a)
						strcpy(sztmp,(char*)sit->second.szSubName.c_str());
					else
						strcpy(sztmp,(char*)sit->second.szChName.c_str());
				}
				else {
					if(networkId == 4)
						wsprintf(sztmp,"BS%d",dit->Service_id);
					else if(networkId == 6 || networkId == 7)
						wsprintf(sztmp,"CS%d",dit->Service_id);
					else
						wsprintf(sztmp,"%d",dit->Service_id);
				}
				progdata.stChName = sztmp;
				stTime = localtime( &stime);
				wsprintf(szDate,"%02d%02d(%s)",stTime->tm_mon+1,stTime->tm_mday,szwday[stTime->tm_wday]);
				progdata.stDate = szDate;
				wsprintf(szDate,"%04dN%02d%02d(%s)",stTime->tm_year+1900,stTime->tm_mon+1,stTime->tm_mday,szwday[stTime->tm_wday]);
				progdata.stYDate = szDate;
				wsprintf(szDate,"%04d^%02d^%02d",stTime->tm_year+1900,stTime->tm_mon+1,stTime->tm_mday);
				progdata.stY2Date = szDate;
				wsprintf(szDate,"%04d-%02d-%02d",stTime->tm_year+1900,stTime->tm_mon+1,stTime->tm_mday);
				progdata.stY2_Date = szDate;
				wsprintf(szDate,"%02d.%02d.%02d",stTime->tm_mon+1,stTime->tm_mday,(stTime->tm_year+1900)%100);
				progdata.stY3_Date = szDate;
				wsprintf(szDate,"%04d%02d%02d%02d%02d",stTime->tm_year+1900,stTime->tm_mon+1,stTime->tm_mday,stTime->tm_hour,stTime->tm_min);
				progdata.stYDateSTime = szDate;
				wsprintf(szDate,"%02d%02d",stTime->tm_hour,stTime->tm_min);
				progdata.stSTime = szDate;
				wsprintf(szDate,"%02dF%02d",stTime->tm_hour,stTime->tm_min);
				progdata.stS2Time = szDate;
				wsprintf(szDate,"%04d%02d%02d(%s)",stTime->tm_year+1900,stTime->tm_mon+1,stTime->tm_mday,szwday[stTime->tm_wday]);
				progdata.stY4_Date = szDate;
				if(stTime->tm_hour >= 0 && stTime->tm_hour <= 4) {
					wsprintf(szDate,"%02d%02d",stTime->tm_hour+24,stTime->tm_min);
					progdata.stSTime28 = szDate;
					wsprintf(szDate,"%02dF%02d",stTime->tm_hour+24,stTime->tm_min);
					progdata.stS2Time28 = szDate;
					time_t stime28 = stime - (24 * 60 * 60);
					stTime = localtime( &stime28);
					wsprintf(szDate,"%02d%02d(%s)",stTime->tm_mon+1,stTime->tm_mday,szwday[stTime->tm_wday]);
					progdata.stDate28 = szDate;
					wsprintf(szDate,"%04dN%02d%02d(%s)",stTime->tm_year+1900,stTime->tm_mon+1,stTime->tm_mday,szwday[stTime->tm_wday]);
					progdata.stYDate28 = szDate;
					wsprintf(szDate,"%04d^%02d^%02d",stTime->tm_year+1900,stTime->tm_mon+1,stTime->tm_mday);
					progdata.stY2Date28 = szDate;
					wsprintf(szDate,"%04d-%02d-%02d",stTime->tm_year+1900,stTime->tm_mon+1,stTime->tm_mday);
					progdata.stY2_Date28 = szDate;
					wsprintf(szDate,"%02d.%02d.%02d",stTime->tm_mon+1,stTime->tm_mday,(stTime->tm_year+1900)%100);
					progdata.stY3_Date28 = szDate;
					wsprintf(szDate,"%04d%02d%02d%02d%02d",stTime->tm_year+1900,stTime->tm_mon+1,stTime->tm_mday,stTime->tm_hour+24,stTime->tm_min);
					progdata.stYDateSTime28 = szDate;
					wsprintf(szDate,"%04d%02d%02d(%s)",stTime->tm_year+1900,stTime->tm_mon+1,stTime->tm_mday,szwday[stTime->tm_wday]);
					progdata.stY4_Date28 = szDate;
				}
				else {
					progdata.stDate28 = progdata.stDate;
					progdata.stSTime28 = progdata.stSTime;
					progdata.stYDate28 = progdata.stYDate;
					progdata.stY2Date28 = progdata.stY2Date;
					progdata.stY2_Date28 = progdata.stY2_Date;
					progdata.stY3_Date28 = progdata.stY3_Date;
					progdata.stS2Time28 = progdata.stS2Time;
					progdata.stYDateSTime28 = progdata.stYDateSTime;
					progdata.stY4_Date28 = progdata.stY4_Date;
				}
				char szvt0[20],szvt1[20],szat[20];
				int vt0 = vt>>4;
				int vt1 = vt&0x0f;
				switch(vt0) {
					case 0:
						strcpy(szvt0,"480i");
						break;
					case 0x0a:
						strcpy(szvt0,"480p");
						break;
					case 0x0b:
						strcpy(szvt0,"1080i");
						break;
					default:
						strcpy(szvt0,"--");
						break;
				}
				switch(vt1) {
					case 1:
						strcpy(szvt1,"(4:3)");
						break;
					case 3:
						strcpy(szvt1,"(16:9)");
						break;
					case 4:
						strcpy(szvt1,"(4:3pan)");
						break;
					default:
						strcpy(szvt1,"(--)");
						break;
				}
				switch(at) {
					case 0x01:
						strcpy(szat,"mon");
						break;
					case 0x02:
						strcpy(szat,"2mon");
						break;
					case 0x03:
						strcpy(szat,"stereo");
						break;
					case 0x07:
						strcpy(szat,"4ch");
						break;
					case 0x08:
						strcpy(szat,"5ch");
						break;
					case 0x09:
						strcpy(szat,"5.1ch");
						break;
					default:
						strcpy(szat,"--");
						break;
				}
				if(aq == 1)
					strcat(szat,"B");
				wsprintf(szDate,"%s%s[%s]",szvt0,szvt1,szat);
				progdata.stAv = szDate;
				string stGenre = "",stGenre2 = "";
				//W
				switch(genre) {
					case 0:
						stGenre = "j[X^";
						switch(genre2) {
							case 0:
								stGenre2 = "莞E";
								break;
							case 1:
								stGenre2 = 	"VC";
								break;
							case 2:
								stGenre2 = 	"WEhLg";
								break;
							case 3:
								stGenre2 = 	"E";
								break;
							case 4:
								stGenre2 = 	"oρEs";
								break;
							case 5:
								stGenre2 = 	"COE";
								break;
							case 6:
								stGenre2 = 	"";
								break;
							case 7:
								stGenre2 = 	"_Ek";
								break;
							case 8:
								stGenre2 = 	"񓹓";
								break;
							case 9:
								stGenre2 = 	"[JEn";
								break;
							case 10:
								stGenre2 = 	"";;
								break;
						}
						break;
					case 1:
						stGenre = "X|[c";
						switch(genre2) {
							case 0:
								stGenre2 = 		"X|[cj[X";
								break;
							case 1:
								stGenre2 = 		"싅";
								break;
							case 2:
								stGenre2 = 		"TbJ[";
								break;
							case 3:
								stGenre2 = 		"St";
								break;
							case 4:
								stGenre2 = 		"̑̋Z";
								break;
							case 5:
								stGenre2 = 		"oEiZ";
								break;
							case 6:
								stGenre2 = 		"IsbNEۑ";
								break;
							case 7:
								stGenre2 = 		"}\EEj";
								break;
							case 8:
								stGenre2 = 		"[^[X|[c";
								break;
							case 9:
								stGenre2 = 		"}EEB^[X|[c";
								break;
							case 10:
								stGenre2 = 		"nEcZ";
								break;
						}
						break;
					case 2:
						stGenre = "^ChV[";
						switch(genre2) {
							case 0:
								stGenre2 =	"|\EChV[";
								break;
							case 1:
								stGenre2 =	"t@bV";
								break;
							case 2:
								stGenre2 =	"炵EZ܂";
								break;
							case 3:
								stGenre2 =	"NE";
								break;
							case 4:
								stGenre2 =	"VbsOEʔ";
								break;
							case 5:
								stGenre2 =	"OE";
								break;
							case 6:
								stGenre2 =	"Cxg";
								break;
							case 7:
								stGenre2 =	"ԑgЉEm点";
								break;
						}
						break;
					case 3:
						stGenre = "h}";
						switch(genre2) {
							case 0:
								stGenre2 =	"h}";
								break;
							case 1:
								stGenre2 =	"COh}";
								break;
							case 2:
								stGenre2 =	"㌀";
								break;
						}
						break;
					case 4:
						stGenre = "y";
						switch(genre2) {
							case 0:
								stGenre2 =	"bNE|bvX";
								break;
							case 1:
								stGenre2 =	"CObNE|bvX";
								break;
							case 2:
								stGenre2 =	"NVbNEIy";
								break;
							case 3:
								stGenre2 =	"WYEt[W";
								break;
							case 4:
								stGenre2 =	"̗wȁE";
								break;
							case 5:
								stGenre2 =	"CuERT[g";
								break;
							case 6:
								stGenre2 =	"LOENGXg";
								break;
							case 7:
								stGenre2 =	"JIPÊǎ";
								break;
							case 8:
								stGenre2 =	"wEMy";
								break;
							case 9:
								stGenre2 =	"wELbY";
								break;
							case 10:
								stGenre2 =	"yE[h~[WbN";
								break;
						}
						break;
					case 5:
						stGenre = "oGeB[";
						switch(genre2) {
							case 0:
								stGenre2 =	"NCY";
								break;
							case 1:
								stGenre2 =	"Q[";
								break;
							case 2:
								stGenre2 =	"g[NoGeB";
								break;
							case 3:
								stGenre2 =	"΂ERfB";
								break;
							case 4:
								stGenre2 =	"yoGeB";
								break;
							case 5:
								stGenre2 =	"oGeB";
								break;
							case 6:
								stGenre2 =	"oGeB";
						}
						break;
					case 6:
						stGenre = "f";
						switch(genre2) {
							case 0:
								stGenre2 =	"m";
								break;
							case 1:
								stGenre2 =	"M";
								break;
							case 2:
								stGenre2 =	"Aj";
						}
						break;
					case 7:
						stGenre = "Aj^B";
						switch(genre2) {
							case 0:
								stGenre2 =	"Aj";
								break;
							case 1:
								stGenre2 =	"COAj";
								break;
							case 2:
								stGenre2 =	"B";
						}
						break;
					case 8:
						stGenre = "hL^[^{";
						switch(genre2) {
							case 0:
								stGenre2 =	"ЉE";
								break;
							case 1:
								stGenre2 =	"jEIs";
								break;
							case 2:
								stGenre2 =	"REE";
								break;
							case 3:
								stGenre2 =	"FEȊwEw";
								break;
							case 4:
								stGenre2 =	"J`[E`";
								break;
							case 5:
								stGenre2 =	"wE|";
								break;
							case 6:
								stGenre2 =	"X|[c";
								break;
							case 7:
								stGenre2 =	"hL^[S";
								break;
							case 8:
								stGenre2 =	"C^r[E_";
						}
						break;
					case 9:
						stGenre = "^";
						switch(genre2) {
							case 0:
								stGenre2 =	"㌀EV";
								break;
							case 1:
								stGenre2 =	"~[WJ";
								break;
							case 2:
								stGenre2 =	"_XEoG";
								break;
							case 3:
								stGenre2 =	"E|";
								break;
							case 4:
								stGenre2 =	"̕EÓT";
						}
						break;
					case 10:
						stGenre = "^";
						switch(genre2) {
							case 0:
								stGenre2 =	"EނEAEghA";
								break;
							case 1:
								stGenre2 =	"|EybgE|";
								break;
							case 2:
								stGenre2 =	"yEpEH|";
								break;
							case 3:
								stGenre2 =	"͌E";
								break;
							case 4:
								stGenre2 =	"Ep`R";
								break;
							case 5:
								stGenre2 =	"ԁEI[goC";
								break;
							case 6:
								stGenre2 =	"Rs[^EsuQ[";
								break;
							case 7:
								stGenre2 =	"bEw";
								break;
							case 8:
								stGenre2 =	"cEw";
								break;
							case 9:
								stGenre2 =	"wEZ";
								break;
							case 10:
								stGenre2 =	"wE";
								break;
							case 11:
								stGenre2 =	"UEi";
								break;
							case 12:
								stGenre2 =	"";
						}
						break;
					case 11:
						stGenre = "";
						switch(genre2) {
							case 0:
								stGenre2 =	"";
								break;
							case 1:
								stGenre2 =	"Q";
								break;
							case 2:
								stGenre2 =	"Љ";
								break;
							case 3:
								stGenre2 =	"{eBA";
								break;
							case 4:
								stGenre2 =	"b";
								break;
							case 5:
								stGenre2 =	"ij";
								break;
							case 6:
								stGenre2 =	"";
								break;
						}
						break;
				}
				char szGenre[200];
				szGenre[0] = 0x00;
				if(!stGenre.empty())
					strcpy(szGenre,stGenre.c_str());
				if(!stGenre2.empty()) {
					strcat(szGenre,"(");
					strcat(szGenre,stGenre2.c_str());
					strcat(szGenre,")");
				}
				progdata.stGenre0 = szGenre;
				progdata.stGenre = stGenre;
				progdata.stGenre2 = stGenre2;
				progdata.stContAll = szcont;
				replace(progdata.stContAll,"\r","");
				for(int ic = 0;ic < strlen(szcont);ic++) {
					if(_ismbblead(szcont[ic]))
						ic++;
					else if(szcont[ic] == '\r') {
						szcont[ic] = 0x00;
						break;
					}
				}
				progdata.stContLine = szcont;

				BOOL bAdd = TRUE;
				// d`FbN
				for(int pl = 0;pl < filedata.progList.size();pl++) {
					if(filedata.progList[pl].stName.compare(progdata.stName) == 0 && filedata.progList[pl].eventId == progdata.eventId) {
						bAdd = FALSE;
						break;
					}
				}
				//vector<PROG_DATA>::iterator pit = filedata.progList.begin();
				//while(pit != filedata.progList.end()) {
				//	if(pit->stName.compare(progdata.stName) == 0 && pit->eventId == progdata.eventId) {
				//		bAdd = FALSE;
				//		break;
				//	}
				//	pit++;
				//}
				if(bAdd) {
					int pos = -1;
					if(filedata.progList.size() > 0) {
						vector<PROG_DATA>::iterator pit = filedata.progList.begin();
						while(pit != filedata.progList.end()) {
							BOOL bIns = FALSE;
							if(pit->vCount < progdata.vCount)
								bIns = TRUE;
							if(bIns) {
								filedata.progList.insert(pit,progdata);
								pos = i;
								break;
							}
							pit++;
						}
					}
					if(pos == -1)
						filedata.progList.push_back(progdata);
				}
			}
			dit++;
		}
		tit++;
	}
	if(filedata.progList.empty()) {
		PROG_DATA progdata;
		progdata.stName = "f[^L܂";
		filedata.progList.push_back(progdata);
	}
	m_FileList.push_back(filedata);
	delete m_pTs;
	SetFileList(hWnd);
	HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
	SetFocus(hList);
	//ListView_SortItems(hList,RenameCompProc,m_RenameSortSubItem);
	MSG msg;
	for(int i = 0;i < 100;i++) {
		if(PeekMessage(&msg,NULL,0,0,PM_REMOVE)){
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return TRUE;
}

LRESULT CALLBACK TsRenameDlgProc(HWND hWnd,UINT meg,WPARAM wp,LPARAM lp)
{
    switch ( meg )
    {
	case WM_INITDIALOG:
		{
			HMENU hSysMenu = GetSystemMenu(hWnd,FALSE);
			InsertMenu(hSysMenu,SC_CLOSE,MF_BYCOMMAND|MF_STRING,IDM_SETUP,"ݒ(&S)...");
			InsertMenu(hSysMenu,SC_CLOSE,MF_BYCOMMAND|MF_STRING,IDM_ABOUT,"o[W(&A)...");

			m_FileList.clear();

			char szItem[100],szData[256];

			m_nReadStartPos = GetPrivateProfileInt("TsRenameDlg","ReadStartPos",m_nReadStartPos,m_szIniPath);
			m_nReadSize = GetPrivateProfileInt("TsRenameDlg","ReadSize",m_nReadSize,m_szIniPath);

			wsprintf(szItem,"FilenameSetSp%d",IDC_TSR_SP1);
			GetPrivateProfileString("TsRenameDlg",szItem,"",szData,256,m_szIniPath);
			//szData[strlen(szData)-1] = 0x00;
			SetDlgItemText(hWnd,IDC_TSR_SP1,szData);
			for(int id = IDC_TSR_SP2;id <= IDC_TSR_SP4;id++) {
				wsprintf(szItem,"FilenameSetSp%d",id);
				GetPrivateProfileString("TsRenameDlg",szItem," ",szData,256,m_szIniPath);
				//szData[strlen(szData)-1] = 0x00;
				SetDlgItemText(hWnd,id,szData);
			}
			wsprintf(szItem,"FilenameSetSp%d",IDC_TSR_SP5);
			GetPrivateProfileString("TsRenameDlg",szItem,"",szData,256,m_szIniPath);
			//szData[strlen(szData)-1] = 0x00;
			SetDlgItemText(hWnd,IDC_TSR_SP5,szData);

			for(int id = IDC_TSR_CMB;id <= IDC_TSR_CMB4;id++) {
				HWND hCmbList = GetDlgItem(hWnd,id);
				ComboBox_AddString(hCmbList,"gp");
				ComboBox_AddString(hCmbList,"ԑg");
				ComboBox_AddString(hCmbList,"CH");
				ComboBox_AddString(hCmbList,"mmdd(w)");
				ComboBox_AddString(hCmbList,"hhmm");
				ComboBox_AddString(hCmbList,"mmdd(w)(28)");
				ComboBox_AddString(hCmbList,"hhmm(28)");
				ComboBox_AddString(hCmbList,"yyyyNmmdd(w)");
				ComboBox_AddString(hCmbList,"yyyyNmmdd(w)(28)");
				ComboBox_AddString(hCmbList,"yyyy^mm^dd");
				ComboBox_AddString(hCmbList,"yyyy^mm^dd(28)");
				ComboBox_AddString(hCmbList,"hhFmm");
				ComboBox_AddString(hCmbList,"hhFmm(28)");
				ComboBox_AddString(hCmbList,"yyyymmddhhmm");
				ComboBox_AddString(hCmbList,"yyyymmddhhmm(28)");
				ComboBox_AddString(hCmbList,"yyyy-mm-dd");
				ComboBox_AddString(hCmbList,"yyyy-mm-dd(28)");
				ComboBox_AddString(hCmbList,"mm.dd.yy");
				ComboBox_AddString(hCmbList,"mm.dd.yy(28)");
				ComboBox_AddString(hCmbList,"f/");
				ComboBox_AddString(hCmbList,"W");
				ComboBox_AddString(hCmbList,"W");
				ComboBox_AddString(hCmbList,"W()");
				ComboBox_AddString(hCmbList,"yyyymmdd(w)");
				ComboBox_AddString(hCmbList,"yyyymmdd(w)(28)");
				ComboBox_AddString(hCmbList,"ԑge(S)");
				ComboBox_AddString(hCmbList,"ԑge(1s)");
				wsprintf(szItem,"FilenameSet%d",id);
				int def = GetPrivateProfileInt("TsRenameDlg",szItem,0,m_szIniPath);
				ComboBox_SetCurSel(hCmbList,def);
			}
			HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);

			DWORD dwStyle;
			dwStyle = ListView_GetExtendedListViewStyle(hList);
			dwStyle |= LVS_EX_FULLROWSELECT;/*| LVS_EX_GRIDLINES*/;
			ListView_SetExtendedListViewStyle(hList, dwStyle);

			LV_COLUMN lvcol;
			lvcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
			lvcol.fmt = LVCFMT_LEFT;
			lvcol.cx = GetPrivateProfileInt("TsRenameDlg","OLDW",100,m_szIniPath);
			lvcol.pszText = "t@C";
			lvcol.iSubItem = 0;
			ListView_InsertColumn(hList, 0, &lvcol);

			lvcol.cx = GetPrivateProfileInt("TsRenameDlg","NEWW",100,m_szIniPath);
			lvcol.pszText = "Vt@C";
			lvcol.iSubItem = 1;
			ListView_InsertColumn(hList, 1, &lvcol);

			lvcol.cx = GetPrivateProfileInt("TsRenameDlg","NAMEW",100,m_szIniPath);
			lvcol.pszText = "ԑg";
			lvcol.iSubItem = 2;
			ListView_InsertColumn(hList, 2, &lvcol);

			lvcol.cx = GetPrivateProfileInt("TsRenameDlg","CHW",100,m_szIniPath);
			lvcol.pszText = "CH";
			lvcol.iSubItem = 3;
			ListView_InsertColumn(hList, 3, &lvcol);

			lvcol.cx = GetPrivateProfileInt("TsRenameDlg","DATEW",100,m_szIniPath);
			lvcol.pszText = "";
			lvcol.iSubItem = 4;
			ListView_InsertColumn(hList, 4, &lvcol);

			lvcol.cx = GetPrivateProfileInt("TsRenameDlg","CONTW",100,m_szIniPath);
			lvcol.pszText = "e";
			lvcol.iSubItem = 5;
			ListView_InsertColumn(hList, 5, &lvcol);

			lvcol.cx = GetPrivateProfileInt("TsRenameDlg","AVW",100,m_szIniPath);
			lvcol.pszText = "f/";
			lvcol.iSubItem = 6;
			ListView_InsertColumn(hList, 6, &lvcol);

			lvcol.cx = GetPrivateProfileInt("TsRenameDlg","GENREW",100,m_szIniPath);
			lvcol.pszText = "W";
			lvcol.iSubItem = 7;
			ListView_InsertColumn(hList, 7, &lvcol);

			if(GetPrivateProfileString("TsRenameDlg","WindowX","100",szData,100,m_szIniPath) > 0) {
				int x = atoi(szData);
				if(GetPrivateProfileString("TsRenameDlg","WindowY","100",szData,100,m_szIniPath) > 0) {
					int y = atoi(szData);
					if(GetPrivateProfileString("TsRenameDlg","WindowCX","930",szData,100,m_szIniPath) > 0) {
						int cx = atoi(szData);
						if(GetPrivateProfileString("TsRenameDlg","WindowCY","500",szData,100,m_szIniPath) > 0) {
							int cy = atoi(szData);
							SetWindowPos(hWnd,NULL,x,y,cx,cy,SWP_NOZORDER);
						}
					}
				}
			}

			m_bNotFileRename = GetPrivateProfileInt("TsRenameDlg","NotRename",m_bNotFileRename,m_szIniPath);
			m_bGopRename = GetPrivateProfileInt("TsRenameDlg","GopRename",m_bGopRename,m_szIniPath);
			m_bWildRename = GetPrivateProfileInt("TsRenameDlg","WildRename",m_bWildRename,m_szIniPath);
			m_bFileDate = GetPrivateProfileInt("TsRenameDlg","FileDate",m_bFileDate,m_szIniPath);
			m_bIconStart = GetPrivateProfileInt("TsRenameDlg","IconStart",m_bIconStart,m_szIniPath);

			int recount = 0;
			while(1) {
				RENAME_DATA redata;
				char szItem[100],szData[1024],szKey[100];
				sprintf(szItem,"TvRockReNameSet%06d",recount);
				GetPrivateProfileString(szItem,"FindText","",szData,1024,m_szIniPath);
				redata.stFind = szData;
				GetPrivateProfileString(szItem,"FindTextCh","",szData,1024,m_szIniPath);
				redata.stFindCh = szData;
				if(redata.stFind.empty() && redata.stFindCh.empty())
					break;
				redata.type = GetPrivateProfileInt(szItem,"FindType",0,m_szIniPath);
				GetPrivateProfileString(szItem,"RenameText","",szData,1024,m_szIniPath);
				redata.stRename = szData;
				GetPrivateProfileString(szItem,"SyoboFind","",szData,1024,m_szIniPath);
				redata.stSyoboFind = szData;
				redata.bSyoboTT = GetPrivateProfileInt(szItem,"SyoboTT",redata.bSyoboTT,m_szIniPath);
				redata.bSyoboNB = GetPrivateProfileInt(szItem,"SyoboNB",redata.bSyoboNB,m_szIniPath);
				redata.bSyoboSB = GetPrivateProfileInt(szItem,"SyoboSB",redata.bSyoboSB,m_szIniPath);
				redata.bSyoboCH = GetPrivateProfileInt(szItem,"SyoboCH",redata.bSyoboCH,m_szIniPath);
				NUM_DATA num;
				GetPrivateProfileString(szItem,"StartTime","0",szData,1024,m_szIniPath);
				num.stime = _atoi64(szData);
				for(int w = 0;w < 7;w++) {
					sprintf(szKey,"WeekCheck%d",w);
					num.bWeekCheck[w] = GetPrivateProfileInt(szItem,szKey,0,m_szIniPath);
				}
				num.sno = GetPrivateProfileInt(szItem,"StartNo",1,m_szIniPath);
				if(num.stime != 0)
					redata.numList.push_back(num);
				for(int ni = 1;;ni++) {
					sprintf(szKey,"StartTime%06d",ni);
					GetPrivateProfileString(szItem,szKey,"0",szData,1024,m_szIniPath);
					num.stime = _atoi64(szData);
					if(num.stime == 0)
						break;
					for(int w = 0;w < 7;w++) {
						sprintf(szKey,"WeekCheck%06d_%d",ni,w);
						num.bWeekCheck[w] = GetPrivateProfileInt(szItem,szKey,0,m_szIniPath);
					}
					sprintf(szKey,"StartNo%06d",ni);
					num.sno = GetPrivateProfileInt(szItem,szKey,1,m_szIniPath);
					redata.numList.push_back(num);
				}
				InserRenameData(NULL,&m_RenameList ,&redata);
				recount++;
			}

			SendMessage(GetDlgItem(hWnd, IDC_TSR_NOTRENAME), BM_SETCHECK, m_bNotFileRename ? BST_CHECKED:BST_UNCHECKED, 0L);
			SendMessage(GetDlgItem(hWnd, IDC_TSR_GOPRENAME), BM_SETCHECK, m_bGopRename ? BST_CHECKED:BST_UNCHECKED, 0L);
			SendMessage(GetDlgItem(hWnd, IDC_TSR_GOPRENAME2), BM_SETCHECK, m_bWildRename ? BST_CHECKED:BST_UNCHECKED, 0L);
			SendMessage(GetDlgItem(hWnd, IDC_TSR_FILEDATE), BM_SETCHECK, m_bFileDate ? BST_CHECKED:BST_UNCHECKED, 0L);
			SendMessage(GetDlgItem(hWnd, IDC_TSR_ICON), BM_SETCHECK, m_bIconStart ? BST_CHECKED:BST_UNCHECKED, 0L);

			DragAcceptFiles(hWnd,TRUE);

			PostMessage(hWnd,WM_SIZE,0,0);
		}
		break;
	case WM_GETMINMAXINFO:
		{
			RECT btnrct,listrct;
			POINT pos;
			GetWindowRect(GetDlgItem(hWnd,IDCANCEL),&btnrct);
			GetWindowRect(GetDlgItem(hWnd,IDC_TSR_LIST),&listrct);
			pos.x = btnrct.right+100;
			pos.y = listrct.top+64;
			ScreenToClient(hWnd,&pos);

			LPMINMAXINFO lpmmi;

			lpmmi = (LPMINMAXINFO)lp;
			lpmmi->ptMinTrackSize.x = pos.x;
			lpmmi->ptMinTrackSize.y = pos.y;
			SetWindowLong(hWnd,DWL_MSGRESULT,0);
			return TRUE;
		}
		break;
	case WM_SIZE:
		{
			RECT dlgrct,listrct;
			POINT pos;
			GetClientRect(hWnd,&dlgrct);
			GetWindowRect(GetDlgItem(hWnd,IDC_TSR_LIST),&listrct);
			pos.x = listrct.left;
			pos.y = listrct.top;
			ScreenToClient(hWnd,&pos);
			int dlgw = dlgrct.right-dlgrct.left;
			int dlgh = dlgrct.bottom-dlgrct.top;
			SetWindowPos(GetDlgItem(hWnd,IDC_TSR_LIST),NULL,0,pos.y,dlgw,dlgh-pos.y,SWP_NOZORDER);
		}
		break;
	case WM_SYSCOMMAND:
		{
			switch (LOWORD(wp)) {
			case IDM_ABOUT:
				DialogBox(hInst,MAKEINTRESOURCE(IDD_ABOUTBOX),hWnd,(DLGPROC)About);
				break;
			case IDM_SETUP:
				DialogBox(hInst,MAKEINTRESOURCE(IDD_SETUP),hWnd,(DLGPROC)SetupDlgProc);
				break;
			}
		}
		break;
    case WM_COMMAND:
		if(LOWORD(wp) >= IDC_TSR_SP1 && LOWORD(wp) <= IDC_TSR_SP5)
		{
			if(HIWORD(wp) == EN_CHANGE)
			{
				SetFileList(hWnd);
				HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
				SetFocus(hList);
				ListView_SortItems(hList,RenameCompProc,m_RenameSortSubItem);
			}
		}
		if(LOWORD(wp) >= IDC_TSR_CMB && LOWORD(wp) <= IDC_TSR_CMB4)
		{
			if(HIWORD(wp) == CBN_SELCHANGE)
			{
				SetFileList(hWnd);
				HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
				SetFocus(hList);
				ListView_SortItems(hList,RenameCompProc,m_RenameSortSubItem);
			}
		}
		else if(LOWORD(wp) == IDM_ALLSEL) {
			HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
			for(int itemNo = 0;itemNo < ListView_GetItemCount(hList);itemNo++) {
				ListView_SetItemState(hList,itemNo,LVIS_SELECTED,LVIS_SELECTED);
			}
			SetFocus(hList);
		}
		else if(LOWORD(wp) == IDM_PROGSEL) {
			HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
			int selitem = ListView_GetNextItem(hList,-1,LVNI_ALL | LVNI_SELECTED);
			if(selitem != -1)
				ProgSel(hWnd,selitem);
			SetFocus(hList);
		}
		else if(LOWORD(wp) == IDM_DELFILE) {
			if(MessageBox(hWnd,"IĂt@CXg폜܂H","Xg폜",MB_ICONQUESTION|MB_YESNO) == IDYES)
				SendMessage(hWnd,WM_COMMAND,IDC_TSR_DEL,0l);
		}
		else if(LOWORD(wp) == IDM_CHGFILE) {
			if(MessageBox(hWnd,"IĂt@C̕ϊsȂ܂H","ϊ",MB_ICONQUESTION|MB_YESNO) == IDYES)
				SendMessage(hWnd,WM_COMMAND,IDOK,0l);
		}
		else if(LOWORD(wp) == IDM_CONT) {
			HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
			int selitem = ListView_GetNextItem(hList,-1,LVNI_ALL | LVNI_SELECTED);
			if(selitem != -1)
				ContDisp(hWnd,selitem);
			SetFocus(hList);
		}
		else if(HIWORD(wp) == 0x00) {
			if(LOWORD(wp) >= IDM_TSR_NAME_SELECT && LOWORD(wp) <= IDM_TSR_NAME_SELECT+100) {
				if(m_nSelectItemNo >= 0 && m_nSelectItemNo < m_FileList.size()) {
					m_FileList[m_nSelectItemNo].nSelNo = (LOWORD(wp) - IDM_TSR_NAME_SELECT);
					//SetFileList(hWnd);
					SetItemText(hWnd,m_nSelectItemNoItem,FALSE);
				}
				break;
			}
			switch ( LOWORD(wp) )
			{
			case IDM_LOAD_CMDLINE:
				{
					if(!m_szCmdLine) {
						ShowWindow(hWnd,SW_SHOW);
						break;
					}
					BOOL bLoad = FALSE;
					BOOL bCancel = FALSE;
					char szFileName[257];
					for(int i = 0;i < strlen(m_szCmdLine);i++) {
						int ii;
						if(m_szCmdLine[i] == ' ')
							continue;
						if(m_szCmdLine[i] == '\"') {
							i++;
							for(ii = i;ii < strlen(m_szCmdLine) && m_szCmdLine[ii] != '\"';ii++);
						}
						else {
							for(ii = i;ii < strlen(m_szCmdLine) && m_szCmdLine[ii] != ' ';ii++);
						}
						strncpy(szFileName,&m_szCmdLine[i],ii-i);
						szFileName[ii-i] = 0x00;
						i = ii;
						if(strcmpi(szFileName,"-AUTO") == 0) {
							m_bAuto = TRUE;
						}
						else if(strcmpi(szFileName,"-QUIT") == 0) {
							m_bQuit = TRUE;
						}
					}
					if(m_bAuto && m_bIconStart)
						ShowWindow(hWnd,SW_SHOWMINNOACTIVE);
					else
						ShowWindow(hWnd,SW_SHOWNOACTIVATE);
					int fileNo = 0;
					for(int i = 0;i < strlen(m_szCmdLine);i++) {
						int ii;
						if(m_szCmdLine[i] == ' ')
							continue;
						if(m_szCmdLine[i] == '\"') {
							i++;
							for(ii = i;ii < strlen(m_szCmdLine) && m_szCmdLine[ii] != '\"';ii++);
						}
						else {
							for(ii = i;ii < strlen(m_szCmdLine) && m_szCmdLine[ii] != ' ';ii++);
						}
						strncpy(szFileName,&m_szCmdLine[i],ii-i);
						szFileName[ii-i] = 0x00;
						i = ii;
						if(strcmpi(szFileName,"-AUTO") == 0) {
							m_bAuto = TRUE;
							continue;
						}
						else if(strcmpi(szFileName,"-QUIT") == 0) {
							m_bQuit = TRUE;
							continue;
						}
						else if(!ReadEpgData(hWnd,fileNo,szFileName)) {
							bCancel = TRUE;
							break;
						}
						fileNo++;
					}
					delete[] m_szCmdLine;
					m_szCmdLine = NULL;
					HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
					SetFocus(hList);
					ListView_SetItemState(hList,0,LVIS_SELECTED,LVIS_SELECTED);
					ListView_SortItems(hList,RenameCompProc,m_RenameSortSubItem);
					if(m_bAuto && !bCancel && fileNo > 0) {
						PostMessage(hWnd,WM_COMMAND,IDM_ALLSEL,0l);				
						PostMessage(hWnd,WM_COMMAND,IDOK,0l);				
						if(m_bQuit)
							PostMessage(hWnd,WM_COMMAND,IDCANCEL,0l);				
					}
				}
				break;
			case IDC_TSR_ALLSEL:
				{
					HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
					for(int itemNo = 0;itemNo < ListView_GetItemCount(hList);itemNo++) {
						ListView_SetItemState(hList,itemNo,LVIS_SELECTED,LVIS_SELECTED);
					}
					SetFocus(hList);
				}
				break;
			case IDC_TSR_NOTRENAME:
				{
				SetFileList(hWnd);
				HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
				SetFocus(hList);
				ListView_SortItems(hList,RenameCompProc,m_RenameSortSubItem);
				}
				break;
			case IDC_TVROCK_NAMECHG:
				if(IDOK == DialogBox(hInst,MAKEINTRESOURCE(IDD_TVROCK_NAME_DLG),hWnd,(DLGPROC)TvRockReNameDlgProc)) {
					SetFileList(hWnd);
					HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
					SetFocus(hList);
					ListView_SortItems(hList,RenameCompProc,m_RenameSortSubItem);
				}
				break;
			case IDM_TSR_NAME_EDIT:
				m_stEdtName = m_FileList[m_nSelectItemNo].progList[m_FileList[m_nSelectItemNo].nSelNo].stName;
				m_stCont = m_FileList[m_nSelectItemNo].progList[m_FileList[m_nSelectItemNo].nSelNo].stCont;
				if(IDOK == DialogBox(hInst,MAKEINTRESOURCE(IDD_TSR_EDITNAME),hWnd,(DLGPROC)NameEditDlgProc)) {
					m_FileList[m_nSelectItemNo].progList[m_FileList[m_nSelectItemNo].nSelNo].stName = m_stEdtName;
					SetItemText(hWnd,m_nSelectItemNoItem,FALSE);
				}
				break;
			case IDC_TSR_DEL:
				{
					HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
					int selitem = -1;
					while((selitem = ListView_GetNextItem(hList,-1,LVNI_ALL | LVNI_SELECTED)) != -1) {
						LV_ITEM item;
						item.mask = LVIF_PARAM;
						item.iItem = selitem;
						item.iSubItem = 0;
						ListView_GetItem(hList,&item);
						vector<FILE_DATA>::iterator fit = m_FileList.begin() + item.lParam;
						int sellparam = item.lParam;
						m_FileList.erase(fit);
						ListView_DeleteItem(hList,selitem);
						for(int itemNo = 0;itemNo < ListView_GetItemCount(hList);itemNo++) {
							LV_ITEM item;
							item.mask = LVIF_PARAM;
							item.iItem = itemNo;
							item.iSubItem = 0;
							ListView_GetItem(hList,&item);
							if(item.lParam > sellparam) {
								item.lParam--;
								ListView_SetItem(hList,&item);
							}
						}
					}
					for(int itemNo = 0;itemNo < ListView_GetItemCount(hList);itemNo++) {
						LV_ITEM item;
						item.mask = LVIF_PARAM;
						item.iItem = itemNo;
						item.iSubItem = 0;
						ListView_GetItem(hList,&item);
						char szMsg[256];
						wsprintf(szMsg,"%d,%d,%s\r\n",itemNo,item.lParam,(char*)m_FileList[item.lParam].stFilePath.c_str());
						OutputDebugString(szMsg);
					}
					//SetFileList(hWnd);
				}
				break;
			case IDOK:
				{
					m_bFileDate = (BST_CHECKED == SendMessage(GetDlgItem(hWnd, IDC_TSR_FILEDATE) , BM_GETCHECK , 0 , 0));
					m_bGopRename = (BST_CHECKED == SendMessage(GetDlgItem(hWnd, IDC_TSR_GOPRENAME) , BM_GETCHECK , 0 , 0));
					m_bWildRename = (BST_CHECKED == SendMessage(GetDlgItem(hWnd, IDC_TSR_GOPRENAME2) , BM_GETCHECK , 0 , 0));
					HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
					int selitem = -1;
					while((selitem = ListView_GetNextItem(hList,selitem,LVNI_ALL | LVNI_SELECTED)) != -1) {
						LV_ITEM item;
						item.mask = LVIF_PARAM;
						item.iItem = selitem;
						item.iSubItem = 0;
						ListView_GetItem(hList,&item);
						vector<FILE_DATA>::iterator fit = m_FileList.begin() + item.lParam;
						if(!fit->bFileNameError && fit->stFilePath != fit->stNewFilePath && !fit->stFilePath.empty() && !fit->stNewFilePath.empty() && !fit->stNewName.empty()) {
							char drv[10],path[256],name[256],ext[256],szName[1024],name2[256],szEx[10];
							_splitpath((char*)fit->stNewFilePath.c_str(),drv,path,name,ext);
							for(int i = 0;i < 100;i++) {
								strcpy(name2,name);
								if(i == 0)
									szEx[0] = 0x00;
								else
									sprintf(szEx,"(%d)",i);
								strcat(name2,szEx);
								_makepath(szName,drv,path,name2,ext);
								if(_access(szName,0) != 0) {
									fit->stNewFilePath = szName;
									break;
								}
							}
							if(MoveFile((char*)fit->stFilePath.c_str(),(char*)fit->stNewFilePath.c_str())) {
								if(m_bWildRename || m_bGopRename) {
									WIN32_FIND_DATA lp;
									char temp[_MAX_PATH+_MAX_PATH+100];

									strcpy(temp,fit->stFilePath.c_str());
									strcat(temp,".*");
									HANDLE h=FindFirstFile(temp,&lp);

									if(INVALID_HANDLE_VALUE != h) {
										do {      
											if(lp.dwFileAttributes != FILE_ATTRIBUTE_DIRECTORY)	{
												string ext;
												ext = &lp.cFileName[fit->stFileName.length()];
												if(!m_bWildRename && ext != ".txt");
												else {
													string stGopFilePath,stGopNewFilePath;
													stGopFilePath = fit->stFilePath + ext;
													stGopNewFilePath = fit->stNewFilePath + ext;
													MoveFile((char*)stGopFilePath.c_str(),(char*)stGopNewFilePath.c_str());
												}
											}
										} while(FindNextFile(h,&lp));
										FindClose(h);
									}
								}
								fit->stFilePath = fit->stNewFilePath;
								_splitpath((char*)fit->stNewFilePath.c_str(),drv,path,name,ext);
								_makepath(szName,NULL,NULL,name,ext);
								fit->stFileName = szName;
								fit->bChange = TRUE;
							}
						}
						if(m_bFileDate && fit->progList[fit->nSelNo].stime != 0) {
							SYSTEMTIME systime;
							FILETIME updatedate,forSetFileTime;
							HANDLE hFile = CreateFile((char*)fit->stFilePath.c_str(),
								  GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
							if(hFile != INVALID_HANDLE_VALUE) {
								memset(&systime, 0, sizeof(systime));
								memset(&updatedate, 0, sizeof(updatedate));
								memset(&forSetFileTime, 0, sizeof(forSetFileTime));
								struct tm* tmt = localtime(&(fit->progList[fit->nSelNo].stime));
								systime.wYear = tmt->tm_year + 1900;
								systime.wMonth = tmt->tm_mon + 1;
								systime.wDay = tmt->tm_mday;
								systime.wDayOfWeek = tmt->tm_wday;
								systime.wHour = tmt->tm_hour;
								systime.wMinute = tmt->tm_min;
								systime.wSecond = tmt->tm_sec;
								systime.wMilliseconds = 0;
								// t@C^C`ɕϊ
								SystemTimeToFileTime(&systime, &updatedate);
								// SetFileTime()pɕϊ
								LocalFileTimeToFileTime(&updatedate, &forSetFileTime);
								SetFileTime(hFile,&forSetFileTime,NULL,&forSetFileTime);
								CloseHandle(hFile);
							}
							if(m_bWildRename || m_bGopRename) {
								WIN32_FIND_DATA lp;
								char temp[_MAX_PATH+_MAX_PATH+100];

								strcpy(temp,fit->stFilePath.c_str());
								strcat(temp,".*");
								HANDLE h=FindFirstFile(temp,&lp);

								if(INVALID_HANDLE_VALUE != h) {
									do {      
										if(lp.dwFileAttributes != FILE_ATTRIBUTE_DIRECTORY)	{
											string ext;
											ext = &lp.cFileName[fit->stFileName.length()];
											if(!m_bWildRename && ext != ".txt");
											else {
												string stGopFilePath;
												stGopFilePath = fit->stFilePath + ext;
												HANDLE hFile = CreateFile((char*)stGopFilePath.c_str(),
													  GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
												if(hFile != INVALID_HANDLE_VALUE) {
													memset(&systime, 0, sizeof(systime));
													memset(&updatedate, 0, sizeof(updatedate));
													memset(&forSetFileTime, 0, sizeof(forSetFileTime));
													struct tm* tmt = localtime(&(fit->progList[fit->nSelNo].stime));
													systime.wYear = tmt->tm_year + 1900;
													systime.wMonth = tmt->tm_mon + 1;
													systime.wDay = tmt->tm_mday;
													systime.wDayOfWeek = tmt->tm_wday;
													systime.wHour = tmt->tm_hour;
													systime.wMinute = tmt->tm_min;
													systime.wSecond = tmt->tm_sec;
													systime.wMilliseconds = 10;
													// t@C^C`ɕϊ
													SystemTimeToFileTime(&systime, &updatedate);
													// SetFileTime()pɕϊ
													LocalFileTimeToFileTime(&updatedate, &forSetFileTime);
													SetFileTime(hFile,&forSetFileTime,NULL,&forSetFileTime);
													CloseHandle(hFile);
												}
											}
										}
									} while(FindNextFile(h,&lp));
									FindClose(h);
								}
							}
						}
					}
					SetFileList(hWnd);
					SetFocus(hList);
					ListView_SortItems(hList,RenameCompProc,m_RenameSortSubItem);
				}
				break;
			case IDCANCEL:
				DestroyWindow(hWnd);
				//::EndDialog(hWnd,IDCANCEL);
				break;
			}
		}
        break;
	case WM_DROPFILES:
		{
			int NameLen = 0;
			char szPathName[MAX_PATH +1] = "";
			HDROP hDrop = (HDROP) wp;

			int Count = DragQueryFile(
			hDrop,0xFFFFFFFF,szPathName,256);

			for(int i=0; i < Count; i++) {
				NameLen = DragQueryFile(hDrop,
				i,szPathName,MAX_PATH);
				szPathName[NameLen] = '\0';
				if(!ReadEpgData(hWnd,i,szPathName))
					break;
			}
			HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
			SetFocus(hList);
			ListView_SetItemState(hList,0,LVIS_SELECTED,LVIS_SELECTED);
			//ListView_SortItems(hList,RenameCompProc,m_RenameSortSubItem);
			DragFinish(hDrop);//J
		}
		break;
	case WM_NOTIFY:
		{
			LPNMLVCUSTOMDRAW	lplvcd;
			LPNMLISTVIEW		lpnmlv;
			LPNMHDR				lpnmhdr;
			lpnmhdr = (LPNMHDR)lp;
			HWND hList=lpnmhdr->hwndFrom;
			if(hList != GetDlgItem(hWnd,IDC_TSR_LIST))
				break;
			switch(lpnmhdr->code) {
				case LVN_COLUMNCLICK:
					{
						LPNMLISTVIEW pnmv = (LPNMLISTVIEW)lp;
						m_bRenameSort[pnmv->iSubItem] = !m_bRenameSort[pnmv->iSubItem];
						m_RenameSortSubItem = pnmv->iSubItem;
						ListView_SortItems(hList,RenameCompProc,pnmv->iSubItem);
					}
					break;
				case NM_CLICK:
					{
						LPNMLISTVIEW lpnmlv = (LPNMLISTVIEW)lp;
						if(lpnmlv->iItem != -1) {
							LV_ITEM item;
							item.mask = LVIF_PARAM;
							item.iItem = lpnmlv->iItem;
							item.iSubItem = 0;
							ListView_GetItem(hList,&item);
							if(lpnmlv->iSubItem == 2 && item.lParam >= 0) {
								ProgSel(hWnd,lpnmlv->iItem);
							}
							else if(lpnmlv->iSubItem == 5 && item.lParam >= 0) {
								ContDisp(hWnd,lpnmlv->iItem);
							}
						}
					}
					break;
				case NM_CUSTOMDRAW :
				// ---- JX^h[ŁAListview̐FݒB
					LPNMLVCUSTOMDRAW lplvcd = (LPNMLVCUSTOMDRAW)lp;
					switch (lplvcd->nmcd.dwDrawStage) {
						case CDDS_PREPAINT:     // `OITEMNGXg
							SetWindowLong(hWnd,DWL_MSGRESULT,(long)CDRF_NOTIFYITEMDRAW);
							return TRUE;
						case CDDS_ITEMPREPAINT: // ITEM`OSUBITEMNGXg
							SetWindowLong(hWnd,DWL_MSGRESULT,(long)CDRF_NOTIFYSUBITEMDRAW);
							return TRUE;
						case CDDS_ITEMPREPAINT|CDDS_SUBITEM:    // SUBITEM`Cxg
							{
								LV_ITEM item;
								item.mask = LVIF_PARAM;
								item.iItem = lplvcd->nmcd.dwItemSpec;
								item.iSubItem = 0;
								ListView_GetItem(hList,&item);
								if(lplvcd->nmcd.dwItemSpec%2) {
									lplvcd->clrTextBk = RGB(0xef,0xef,0xff);
								}
								else {
									lplvcd->clrTextBk = RGB(0xf4,0xf4,0xff);
								}
								if(m_FileList[item.lParam].progList.size() > 1 && lplvcd->iSubItem == 2)
									lplvcd->clrTextBk = RGB(0xb7,0xff,0xb7);
								if(m_FileList[item.lParam].bFileNameError && lplvcd->iSubItem == 1)
									lplvcd->clrTextBk = RGB(0xff,0,0);
								SetWindowLong(hWnd,DWL_MSGRESULT,(long)CDRF_NEWFONT);
							}
							return TRUE;
					}
					break;
			}
		}
		break;
	case WM_DESTROY:
		{
			if(soc != -1){		/* ɒʐM̏ꍇ̓LZ */
				/* \Pbgj */
				SocketClose(hWnd);
			}
			char szItem[100];
			char szData[256];
			HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
			wsprintf(szData,"%d",ListView_GetColumnWidth(hList,0));
			WritePrivateProfileString("TsRenameDlg","OLDW",szData,m_szIniPath);
			wsprintf(szData,"%d",ListView_GetColumnWidth(hList,1));
			WritePrivateProfileString("TsRenameDlg","NEWW",szData,m_szIniPath);
			wsprintf(szData,"%d",ListView_GetColumnWidth(hList,2));
			WritePrivateProfileString("TsRenameDlg","NAMEW",szData,m_szIniPath);
			wsprintf(szData,"%d",ListView_GetColumnWidth(hList,3));
			WritePrivateProfileString("TsRenameDlg","CHW",szData,m_szIniPath);
			wsprintf(szData,"%d",ListView_GetColumnWidth(hList,4));
			WritePrivateProfileString("TsRenameDlg","DATEW",szData,m_szIniPath);
			wsprintf(szData,"%d",ListView_GetColumnWidth(hList,5));
			WritePrivateProfileString("TsRenameDlg","CONTW",szData,m_szIniPath);
			wsprintf(szData,"%d",ListView_GetColumnWidth(hList,6));
			WritePrivateProfileString("TsRenameDlg","AVW",szData,m_szIniPath);
			wsprintf(szData,"%d",ListView_GetColumnWidth(hList,7));
			WritePrivateProfileString("TsRenameDlg","GENREW",szData,m_szIniPath);
			long style = GetWindowLong(hWnd,GWL_STYLE);
			if(!(style & WS_MINIMIZE || style & WS_MAXIMIZE)) {
				RECT dlgrct;
				GetWindowRect(hWnd,&dlgrct);
				wsprintf(szData,"%d",dlgrct.left);
				WritePrivateProfileString("TsRenameDlg","WindowX",szData,m_szIniPath);
				wsprintf(szData,"%d",dlgrct.top);
				WritePrivateProfileString("TsRenameDlg","WindowY",szData,m_szIniPath);
				wsprintf(szData,"%d",dlgrct.right-dlgrct.left);
				WritePrivateProfileString("TsRenameDlg","WindowCX",szData,m_szIniPath);
				wsprintf(szData,"%d",dlgrct.bottom-dlgrct.top);
				WritePrivateProfileString("TsRenameDlg","WindowCY",szData,m_szIniPath);
			}
			for(int id = IDC_TSR_SP1;id <= IDC_TSR_SP5;id++) {
				char sztmp[256];
				GetDlgItemText(hWnd,id,szData,256);
				wsprintf(sztmp,"\"%s\"",szData);
				wsprintf(szItem,"FilenameSetSp%d",id);
				WritePrivateProfileString("TsRenameDlg",szItem,sztmp,m_szIniPath);
			}
			for(int id = IDC_TSR_CMB;id <= IDC_TSR_CMB4;id++) {
				HWND hCmbList = GetDlgItem(hWnd,id);
				int def = ComboBox_GetCurSel(hCmbList);
				wsprintf(szItem,"FilenameSet%d",id);
				wsprintf(szData,"%d",def);
				WritePrivateProfileString("TsRenameDlg",szItem,szData,m_szIniPath);
			}
			m_bNotFileRename = (BST_CHECKED == SendMessage(GetDlgItem(hWnd, IDC_TSR_NOTRENAME) , BM_GETCHECK , 0 , 0));
			m_bGopRename = (BST_CHECKED == SendMessage(GetDlgItem(hWnd, IDC_TSR_GOPRENAME) , BM_GETCHECK , 0 , 0));
			m_bWildRename = (BST_CHECKED == SendMessage(GetDlgItem(hWnd, IDC_TSR_GOPRENAME2) , BM_GETCHECK , 0 , 0));
			m_bFileDate = (BST_CHECKED == SendMessage(GetDlgItem(hWnd, IDC_TSR_FILEDATE) , BM_GETCHECK , 0 , 0));
			m_bIconStart = (BST_CHECKED == SendMessage(GetDlgItem(hWnd, IDC_TSR_ICON) , BM_GETCHECK , 0 , 0));
			wsprintf(szData,"%d",m_bNotFileRename);
			WritePrivateProfileString("TsRenameDlg","NotRename",szData,m_szIniPath);
			wsprintf(szData,"%d",m_bGopRename);
			WritePrivateProfileString("TsRenameDlg","GopRename",szData,m_szIniPath);
			wsprintf(szData,"%d",m_bWildRename);
			WritePrivateProfileString("TsRenameDlg","WildRename",szData,m_szIniPath);
			wsprintf(szData,"%d",m_bFileDate);
			WritePrivateProfileString("TsRenameDlg","FileDate",szData,m_szIniPath);
			wsprintf(szData,"%d",m_bIconStart);
			WritePrivateProfileString("TsRenameDlg","IconStart",szData,m_szIniPath);
			wsprintf(szData,"%d",m_nReadStartPos);
			WritePrivateProfileString("TsRenameDlg","ReadStartPos",szData,m_szIniPath);
			wsprintf(szData,"%d",m_nReadSize);
			WritePrivateProfileString("TsRenameDlg","ReadSize",szData,m_szIniPath);
			PostQuitMessage(0);
		}
		break;
	case WSOCK_GETHOST:						/* T[õzXg֐̃Cxg */
		/* zXg񂩂IPAhX擾ĐڑJn */
		HTTPGetHostToIPaddr(hWnd,wp,lp);
		break;

	case WSOCK_SELECT:						/* \PbgCxg̃bZ[W̏ꍇ(WSAAsyncSelect֐ɂēo^) */
		/* G[̔ */
		if(soc != -1 && WSAGETSELECTERROR(lp) != 0){
			SocketError(hWnd,"SocketCxg̒ʒmŃG[܂B");
			break;
		}
		/* ׂ\Pbg */
		if(soc != (int)wp){
			break;
		}
		/* \PbgCxg̏s */
		switch(WSAGETSELECTEVENT(lp))
		{
		case FD_CONNECT:					/* T[oւ̐ڑCxg */
			/* HTTPNGXg𑗐M */
			HTTPSendRequest(hWnd);
			break;

		case FD_READ:						/* Mobt@Ƀf[^鎖Cxg */
			/* f[^MĒ~ς */
			HTTPRecvData(hWnd);
			break;

		case FD_CLOSE:						/* T[oւ̐ڑICxg */
			/* ڑI */
			HTTPClose(hWnd);
			break;
		}
		break;
	}
    return 0;
}

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: ɃR[h}ĂB
	// O[oĂ܂B
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_TSRENAME, szWindowClass, MAX_LOADSTRING);

	/*  */
	WSADATA wsaData;
	soc = -1;
	hGetHost = NULL;
	WSAStartup(MAKEWORD(2,0), &wsaData);

	InitCommonControls();

	char szModulePath[256],drv[10],path[256],name[256],ext[256];
	GetModuleFileName(NULL,szModulePath,256);
	_splitpath(szModulePath,drv,path,name,ext);
	_makepath(m_szIniPath,drv,path,name,".ini");

    HWND hDlg= CreateDialog(hInstance,MAKEINTRESOURCE(IDD_TSRENAME_DLG),
        NULL,(DLGPROC)TsRenameDlgProc);
    ShowWindow(hDlg,SW_HIDE);

	m_szCmdLine = new char[strlen(lpCmdLine)+1];
	strcpy(m_szCmdLine,lpCmdLine);
	PostMessage(hDlg,WM_COMMAND,IDM_LOAD_CMDLINE,0l);

	MSG msg;
	HACCEL hAccel= LoadAccelerators(hInstance,MAKEINTRESOURCE(IDC_TSRENAME));
	while (GetMessage(&msg,NULL,0,0) )
	{
		if ( !TranslateAccelerator(hDlg,hAccel,&msg) && !IsDialogMessage(hDlg,&msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	WSACleanup();

	return 0;

	//return (int) DialogBox(hInstance,MAKEINTRESOURCE(IDD_TSRENAME_DLG),	NULL,(DLGPROC)TsRenameDlgProc);
}



//
//  ֐ : MyRegisterClass()
//
//  ړI : EBhE NXo^܂B
//
//  Rg :
//
//    ̊֐юǵA'RegisterClassEx' ֐ǉꂽ
//     Windows 95 O Win32 VXeƌ݊ꍇɂ̂ݕKvłB
//    AvP[VA֘Atꂽ 
//    `̏ACR擾ł悤ɂɂ́A
//    ̊֐ĂяoĂB
//

// o[W{bNX̃bZ[W nhłB
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}
